2016-06-21  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.99 released.

2016-06-21  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.99 released.

2016-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.98 released.

2016-01-25  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.97 released.

2016-01-16  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.96 released.

2016-01-13  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.95 released.

2016-01-11  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.94 released.

2016-01-05  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.93 released.

2016-01-04  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.92 released.

2015-09-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.91 released.

2015-05-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.90 released.

2015-04-27  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.89 released.

2015-04-13  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.88 released.

2015-02-28  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.87 released.

2015-02-01  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.86 released.

2015-01-12  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.85 released.

2014-11-18  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.84 released.

2014-11-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.83 released.

2014-11-01  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.82 released.

2014-10-18  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.81 released.

2014-10-16  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.80 released.

2014-09-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.79 released.

2014-06-29  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.78 released.

2014-05-30  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.77 released.

2014-05-15  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.76 released.

2014-05-15  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.75 released.

2014-05-13  Jerry James  <james@xemacs.org>

	* .cvsignore: Remove.
	* .hgignore: New file.
	* cc-mode.texi: Update for texinfo 5.x.  Restore CVS keyword
	expansion.

2013-10-28  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.74 released.

2013-10-22  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.73 released.

2013-10-14  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.72 released.

2013-09-22  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.71 released.

2013-09-19  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.70 released.

2013-06-03  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.69 released.

2013-05-28  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.68 released.

2013-05-07  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.67 released.

2013-05-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.5

	* ChangeLog: Update for patch releases 5.32.3 and 5.32.5.

	* cc-defs.el (c-version): Increment to 5.32.5.

	* *.el, cc-mode.texi: Add 2012 and 2013 to copyright notices.

2013-05-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Eliminate variable c-standard-font-lock-fontify-region-function.
	* cc-mode.el (c-standard-font-lock-fontify-region-function): Remove.
	(c-font-lock-fontify-region, c-after-font-lock-init): Adapt.

2013-04-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Handle arbitrarily long C++ member initialisation lists.  Test files.
	* tests/member-init-1.cc: Remove erroneous code which clashes with
	this change.
	* tests/member-init-1.res: Recreated.
	* tests/class-31.cc: Renamed from member-9.cc; replace a
	constructor with a member init list by a class with inheritance.
	* tests/class-31.res: Renamed from member-9.res and recreated.

2013-04-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Handle arbitrarily long C++ member initialisation lists.
	Made necessary by change 2012-02-26-ell-m, where a search limit of
	500 was introduced.

	* cc-engine.el (c-back-over-member-initializers): new function.
	(c-guess-basic-syntax): New CASE 5R (extracted from 5B) to handle
	(most) member init lists.

2013-04-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.66 released.

2013-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct the placement of c-cpp-delimiters when there're #s not at col 0.
	* cc-langs.el (c-anchored-cpp-prefix): Reformulate and place a
	submatch around the #.
	* cc-mode.el (c-neutralize-syntax-in-and-mark-CPP): Start a search
	at BOL.  Put the c-cpp-delimiter category text propertiy on the #,
	not BOL.

2013-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Reformulate java imenu-generic-expression.  Contributed by Filipp Gunbin.
	The old expression contained ill formed regexps.

	* cc-menus.el (cc-imenu-java-ellipsis-regexp)
	(cc-imenu-java-type-spec-regexp, cc-imenu-java-comment-regexp)
	(cc-imenu-java-method-arg-regexp): New defconsts.
	(cc-imenu-java-build-type-args-regex): New defun.
	(cc-imenu-java-generic-expression): Fixed, to remove "ambiguous"
	handling of spaces in the regexp.

2013-04-04  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.65 released.

2013-04-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Handle `parse-partial-sexp' landing inside a comment opener.
	Also adapt to the new values of element 7 of a parse state.

	* cc-engine.el (c-state-pp-to-literal): New optional parameter
	`not-in-delimiter'.  Handle being inside comment opener.
	(c-invalidate-state-cache-1): Reckon with an extra "invalid"
	character in case we're typing a '*' after a '/'.
	(c-literal-limits): Handle the awkward "not-in-delimiter" cond arm
	instead by passing the parameter to c-state-pp-to-literal.

	* cc-fonts.el (c-font-lock-doc-comments): New handling for elt. 7
	of a parse state.

2013-03-06  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.64 released.

2013-03-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct the position of point in some line-up functions.
	* cc-align.el (c-lineup-whitesmith-in-block, c-lineup-assignments)
	(c-lineup-gcc-asm-reg ): take position of point at column 0 rather
	than at a random place in the line.
	* cc-mode.texi (Custom Line-Up): State explicitly that point
	starts at a random position in the line being indented.

2013-03-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Replace `last-command-event' by `last-command-char' in XEmacs.
	* cc-defs.el (c-last-command-char): New macro.
	* cc-align.el (c-semi&comma-inside-parenlist)
	(c-semi&comma-no-newlines-before-nonblanks)
	(c-semi&comma-no-newlines-for-oneline-inliners): Use the new macro
	in place of `last-command-event'.
	* cc-cmds.el (c-electric-pound, c-electric-brace)
	(c-electric-slash, c-electric-semi&comma, c-electric-lt-gt)
	(c-electric-paren, c-electric-continued-statement): Use the new
	macro in place of `last-command-event'.

2013-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.63 released.

2013-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.62 released.

2013-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.62 released.

2013-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.62 released.

2013-02-08  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.62 released.

2013-02-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix bug in the state cache mechanism.  Remove 'BOD "strategy".  Refactor.
	* cc-engine.el (c-get-fallback-scan-pos): Remove.
	(c-parse-state-get-strategy): Don't return 'BOD any more.
	(c-append-lower-brace-pair-to-state-cache): Extra parameter HERE
	instead of narrowing.  Widen to top of buffer before searching
	backwards for a brace pair.
	(c-state-push-any-brace-pair): Add HERE parameter to function
	call.
	(c-append-to-state-cache): Extra parameter HERE in place of
	narrowing.  Narrow to parameter HERE, in place of being called
	narrowed.
	(c-remove-stale-state-cache): Extra parameter HERE in place of
	narrowing.  Check there's an open brace in the cache before
	searching for its match.
	(c-invalidate-state-cache-1): Add HERE parameter to function call.
	(c-parse-state-1): Don't narrow here for 'forward strategy,
	instead passing extra parameter HERE to several functions.  Remove
	'BOD strategy.

2013-01-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Amend to fontify /regexp/s in actions correctly.
	* cc-awk.el (c-awk-harmless-char-re, c-awk-harmless-string*-re)
	(c-awk-harmless-string*-here-re): braces, parens and semicolons
	are no longer included.
	(c-awk-harmless-line-char-re, c-awk-harmless-line-string*-re):
	What used to be these variables without "-line" in the name.
	(c-awk-neutral-re): { is no longer neutral.  Escaped newlines now
	are.
	(c-awk-non-arith-op-bra-re): Now also matches {.
	(c-awk-pre-exp-alphanum-kwd-re): New regexp to match "print",
	"return", and "case".
	(c-awk-kwd-regexp-sign-re): New, to match "print", etc., followed
	by /.
	(c-awk-syntax-tablify-/): Check special cases "print /re/", etc.
	(c-awk-set-syntax-table-properties): Extend FSM to handle
	{,},(,),;.

	awk-face-2.awk, awk-face-2.face: New test files for /regexp/s.

2013-01-27  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.60 released.

2013-01-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	AWK Mode: Fix indentation bug at top level.
	* cc-engine.el (c-guess-basic-syntax): Move CASE 5P to just before
	CASE 5D.
	* awk-top-1.awk, awk-top-1.res:  Add an extra test for this.

2013-01-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix a bug in the state cache mechanism.  Refactor this a bit.

	* cc-engine.el (c-parse-state-get-strategy): Remove the
	`cache-pos' element from the return value.
	(c-append-lower-brace-pair-to-state-cache): "Narrow" to end of
	buffer to enable proper searching from beyond HERE.  Amend the
	test for detecting the sought brace pair.  Amend the value written
	to the "brace desert cache" when the brace isn't found.
	(c-remove-stale-state-cache): Rename `good-pos' to `start-point',
	and several other variables analogously.
	(c-remove-stale-state-cache-backwards): Change `cache-pos' from a
	parameter to a locally calculated variable.
	(c-parse-state-1): Change the calling conventions to the two
	defuns involving `cache-pos'.

2013-01-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix bugs in the state cache.  Enhance a debugging mechanism.

	* cc-engine.el (c-state-old-cpp-beg-marker)
	(c-state-old-cpp-end-marker): New variables.
	(c-parse-state-get-strategy): Don't use "brace at column zero"
	strategy for C++.
	(c-append-lower-brace-pair-to-state-cache): Repair algorithm.
	Start a backward search for "}" definitively outside CPP
	constructs.
	(c-remove-stale-state-cache): Inform the caller of a need to
	search back for a brace pair in certain circumstances.
	(c-state-maybe-marker): New macro.
	(c-parse-state): Reuse markers when appropriate.
	(c-parse-state-point): New variable.
	(c-record-parse-state-state): Record old parse state with
	`copy-tree'.  Record previous value of point.
	(c-replay-parse-state-state): Replay markers more correctly.
	(c-debug-parse-state-double-cons): New debugging function.
	(c-debug-parse-state): Call the above new function.
	(c-toggle-parse-state-debug): Output a confirmatory message.

	* cc-mode.el (c-before-change, c-after-change): Call
	c-invalidate-state-cache from `c-before-change' instead of
	`c-after-change'.

2012-12-28  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.59 released.

2012-12-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Speed up fontification where there's large brace blocks.
	* cc-fonts.el (c-font-lock-enclosing-decls): Add a limit to a call
	of c-beginning-of-decl-1.

2012-12-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.58 released.

2012-12-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Make CC Mode not hang when _some_ lines end in CRLF.
	* cc-engine.el (c-backward-comments): Add code to work around
	`forward-comment' not recognizing ^M as whitespace.

2012-09-11  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.57 released.

2012-09-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct the handling of two c-state-cache state variables.
	* cc-engine.el (c-state-cache-init): Initialise
	c-state-semi-nonlit-pos-cache\(-limit\)? properly.
	(c-record-parse-state-state): record
	c-state-semi-nonlit-pos-cache\(-limit\)?.

2012-09-03  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.56 released.

2012-08-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	AWK Mode: make auto-newline work when there's "==" in the pattern.
	* cc-cmds.el (c-point-syntax): Handle virtual semicolons
	correctly.
	* cc-engine.el (c-guess-basic-syntax CASE 5A.3): Test more
	rigorously for "=" token.

2012-05-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.3

	* cc-defs.el (c-version): Increment to 5.32.3.

	* *.el, cc-mode.texi: Add 2012 to copyright notices.

2012-04-23  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.55 released.

2012-04-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix erroneous commit.

2012-04-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Adding a ) can hide the resulting (..) from searches.  Fix it.

	* cc-engine (c-append-lower-brace-pair-to-state-cache): Bound the
	backward search to the position of the existing (.

2012-04-16  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.54 released.

2012-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Ensure searching for keywords is case sensitive.

        * cc-cmds.el (c-electric-brace, c-electric-lt-gt)
	(c-electric-paren c-beginning-of-defun, c-end-of-defun)
	(c-defun-name, c-mark-function c-cpp-define-name)
	(c-comment-indent, c-scan-conditionals c-indent-defun)
	(c-context-line-break): bind case-fold-search to nil.

	* cc-mode.el (c-font-lock-fontify-region): bind case-fold-search
	to nil.

2012-04-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Make imenu work again for Objective C Mode.
	* cc-menus.el (cc-imenu-objc-generic-expression): Correct the
	*-index values, these having been disturbed by a previous change
	in 2011-08.

2012-04-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct two search limits in c-before-change-check_<>-operators.
	* cc-engine.el (c-before-change-check-<>-operators): Make the
	correction.

	* cc-mode.texi (c-offsets-alist): Correct a typo.

2012-03-19  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.53 released.

2012-03-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Further optimise the handling of large macros.

	* cc-engine.el (c-crosses-statement-barrier-p): Use a limit to a
	call of `c-literal-limits'.
	(c-determine-+ve-limit): New function.
	(c-at-macro-vsemi-p): Move `c-in-literal' to the bottom of an `and'.
	(c-guess-basic-syntax): In macros, restrict a search limit to
	2000.  In CASE 5B, restrict a search limit to 500.
	(c-just-after-func-arglist-p): Obviouly wrong `or' -> `and'.

	* cc-mode.el (c-neutralize-syntax-in-and-mark-CPP): Restrict
	macro bounds to +-500 from after-change's BEG END.

2012-03-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mark-defun): Leave a mark, and extend region when
	command is repeated.

2012-03-06  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.52 released.

2012-03-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Depessimize the handling of very large macros.

	* cc-engine.el (c-macro-cache, c-macro-cache-start-pos):
	(c-macro-cache-syntactic): New variables to implement a one
	element macro cache.
	(c-invalidate-macro-cache): New function.
	(c-beginning-of-macro, c-end-of-macro, c-syntactic-end-of-macro):
	Adapt to use the new cache.
	(c-state-safe-place): Use better the cache of safe positions.
	(c-state-semi-nonlit-pos-cache)
	(c-state-semi-nonlit-pos-cache-limit): New variables for...
	(c-state-semi-safe-place): New function.  Here, in a macro is
	"safe".
	(c-invalidate-state-cache-1): New stuff for
	c-state-semi-safe-place.
	(c-in-literal, c-literal-limits, c-determine-limit-get-base): Use
	c-state-semi-safe-place.

	* cc-langs.el (c-get-state-before-change-functions): Add
	c-invalidate-macro-cache to the C, C++, Obj entries.

2012-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise macro handling with a 1 element cache of beginning and
	end.  Make the default of c-macro-names-with-semicolon nil.  See
	2012-03-02 for details.

2012-02-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise c-state-safe-place.  See 2012-03-02 for details.

2012-02-14  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.51 released.

2012-02-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix a loop in c-set-fl-decl-start.
	* cc-engine.el (c-set-fl-decl-start): Add a check that
	c-backward-syntactic-ws actually moves backwards.

2012-02-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix infinite loop with long macros.
	* cc-engine.el (c-state-safe-place): Handle macros properly.

2012-02-09  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.50 released.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix spurious recognition of c-in-knr-argdecl.

	* cc-engine.el (c-in-knr-argdecl): Check for '=' in a putative K&R
	region.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Test for keyword @implementation in a #pragma.  This used to
	loop.

2012-02-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-objc-directive): Prevent looping in
	"#pragma mark @implementation".

2012-01-19  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.49 released.

2012-01-19  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.48 released.

2012-01-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Eliminate sluggishness and hangs in fontification of "semicolon
	deserts".

	* cc-engine.el (c-state-nonlit-pos-interval): change value 10000
	-> 3000.
	(c-state-safe-place): Reformulate so it doesn't stack up an
	infinite number of wrong entries in c-state-nonlit-pos-cache.
	(c-determine-limit-get-base, c-determine-limit): New functions to
	determine backward search limits disregarding literals.
	(c-find-decl-spots): Amend commenting.
	(c-cheap-inside-bracelist-p): New function which detects "={".

	* cc-fonts.el (c-make-font-lock-BO-decl-search-function): Give a
	limit to a backward search.
	(c-font-lock-declarations): Fix an occurrence of point being
	undefined.  Check additionally for point being in a bracelist or
	near a macro invocation without a semicolon so as to avoid a
	fruitless time consuming search for a declarator.  Give a more
	precise search limit for declarators using the new
	c-determine-limit.

2012-01-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Correct a test to do with C-y:
	* cc-mode.el (c-after-change): Correct a singular-plural
	confusion.

2012-01-13  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.48 released.

2012-01-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix filling for when filladapt mode is enabled.

	* cc-cmds.el (c-fill-paragraph): In the invocation of
	c-mask-paragraph, pass in `fill-paragraph' rather than
	`fill-region-as-paragraph'.  (This is a reversion of a previous
	change.)
	* cc-mode.el (c-basic-common-init): Make
	fill-paragraph-handle-comment buffer local and set it to nil.

2012-01-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix Emacs bug #10463 - put `widen's around the critical spots.

	* cc-engine.el (c-in-literal, c-literal-limits): put a widen
	around each invocation of c-state-pp-to-literal.  Remove an unused
	let variable.

2012-01-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.47 released.

2012-01-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.46 released.

2012-01-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Optimise font locking in long enum definitions.

	* cc-fonts.el (c-font-lock-declarations): Add an extra arm to a
	cond form to handle enums.
	* cc-langs.el (c-enums-contain-decls): New lang variable.
	* cc-mode.el (c-font-lock-fontify-region): Correct a typo.

2011-12-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce a mechanism to widen the region used in context font
	locking.  Use this to protect declarations from losing their
	contexts.

	* cc-langs.el (c-before-font-lock-functions): replace
	c-set-fl-decl-start with c-change-set-fl-decl-start (Renaming).
	(c-before-context-fontification-functions): new defvar, a list of
	functions to be run just before context (etc.) font locking.

	* cc-mode.el (c-extend-font-lock-region-for-macros): new,
	functionality extracted from c-neutralize-syntax-in-and-mark-CPP.
	(c-in-after-change-fontification): new variable.
	(c-after-change): Set c-in-after-change-fontification.
	(c-set-fl-decl-start): Rejig its interface, so it can be called
	from both after-change and context fontifying.
	(c-change-set-fl-decl-start, c-context-set-fl-decl-start): new
	functions.
	(c-standard-font-lock-fontify-region-function): new variable.
	(c-font-lock-fontify-region): new function

2011-12-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix unstable fontification inside templates.

	* cc-langs.el (c-before-font-lock-functions): newly created from
	the singular version.  The (c c++ objc) entry now additionally has
	c-set-fl-decl-start.  The other languages (apart from AWK) have
	that as a single entry.

	* cc-fonts.el (c-font-lock-enclosing-decls): The functionality for
	"local" declarations has been extracted to c-set-fl-decl-start.

	* cc-mode.el: (c-common-init, c-after-change): Changes due to
	pluralisation of c-before-font-lock-functions.
	(c-set-fl-decl-start): New function, extraced from
	c-font-lock-enclosing-decls and enhanced.
	(top level): Only advise the font-lock change functions when
	font-lock-extend-after-change-region-function is not defined.

2011-12-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Convert some British English spellings to American English.

2011-12-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Large brace-block initialisation makes CC Mode slow: Fix.  Tidy up
	and accelerate c-in-literal, etc. by using the c-parse-state
	routines.  Limit backward searching in c-font-lock-enclosing.decl.

	* cc-engine.el (c-state-pp-to-literal): Return the pp-state and
	literal type in addition to the limits.
	(c-state-safe-place): New defun, extracted from
	c-state-literal-at.
	(c-state-literal-at): Use the above new defun.
	(c-slow-in-literal, c-fast-in-literal): Removed.
	(c-in-literal, c-literal-limits): Amended to use
	c-state-pp-to-literal.

	* cc-fonts.el (c-font-lock-enclosing-decls): Check for being in a
	literal.  Add a limit for backward searching.

	* cc-mode.el (awk-mode): Don't alias c-in-literal to
	c-slow-in-literal.

2011-12-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Add the switch statement to AWK Mode.

	cc-awk (awk-font-lock-keywords): Add "switch", "case", "default"
	to the keywords regexp.

	cc-langs (c-label-kwds): Let AWK take the same expression as the
	rest.
	(c-nonlabel-token-key): Allow string literals for AWK.  Refactor
	for the other modes.

2011-10-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix bug #9560, sporadic wrong indentation; improve instrumentation of
	c-parse-state.
	* cc-engine.el (c-append-lower-brace-pair-to-state-cache): correct faulty
	logical expression.

	(c-parse-state-state, c-record-parse-state-state)
	c-replay-parse-state-state): New defvar/defuns.
	(c-debug-parse-state): Use new functions.

2011-10-18  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.46 released.

2011-10-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.2

	* ChangeLog: Update for patch release 5.32.2.

	* cc-defs.el (c-version): Increment to 5.32.2

2011-10-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhance cc-bytecomp-ignore-obsolete to cope with the missing
	function `byte-compile-obsolete' in Emacs >= 24.

	* cc-bytecomp.el: (top-level): Add variable cc-bytecomp-push-vars.
	Set this and similar variables to nil each time the file is
	loaded.
	(cc-bytecomp-setup-environment, cc-bytecomp-restore-environment):
	Add clauses to setup and restore "pushed" variables.
	(cc-bytecomp-push): New macro to "push" a variable onto an
	internal stack.
	(cc-bytecomp-ignore-obsolete): Add a superfluous check to suppress
	a compiler warning
	(cc-bytecomp-ignore-obsolete): In Emacs >= 24, use
	byte-compile-not-obsolete-funcs to mark a function as obsolete.

2011-10-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fontify Java @annotations with c-preprocessor-face-name instead of
	c-annotation-face.  Protect against a one line change misfontifying an
	annotation as a variable declaration.  Fix a "minor" bug.

	* cc-fonts.el (c-annotation-face): Remove
	(c-basic-matchers-before): Move the stanza for Java @annotations here
	from c-basic-matchers-after.  Replace c-annotation-face by c-preprocessor
	face name.
	(c-font-lock-enclosing-decls): Check that c-opt-block-decls-with-vars-key
	is non-nil before using it.

	* annotations-1.face: recalculate this file.

2011-09-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (top level): Add a test for the existence of delete-dups.

	* cc-fix.el (top level): (defun delete-dups) when necessary.

2011-09-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/index.php, admin/release.php: Update version to 5.32.1

2011-09-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for patch release 5.32.1.

	* cc-defs.el (c-version): Increment to 5.32.1

2011-09-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Patch release 5.32.1

	* cc-defs (c-version): Increment to 5.32.1

2011-09-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs (c-emacs-features): add-local-hook-test: Put a save-excursion
	round the buffer manipulation.  Error detected by XEmacs byte compiler.

2011-09-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el: Reapply the changes of 2011-08-28

	* cc-menus.el: Reapply the change of 2011-08-27.

2011-09-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fix.el, cc-fonts.el, cc-guess.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-mode.el, cc-styles.el, cc-subword.el, cc-vars.el, cc-align.el, cc-awk.el, cc-bytecomp.el, cc-cmds.el, cc-compat.el, cc-defs.el, cc-engine.el:
	Correct the copyright and license statements for release 5.32.

	* cc-defs.el (c-next-single-property-change)
	(c-search-backward-char-property): For XEmacs, only use
	next/previous-single-char-property-change in versions >= 2005-01-25

	* cc-fonts.el, cc-menus.el: Restore to the state of Release_5_32.

2011-08-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el:
	Fix - typing on a C++ inher-intro or inher-cont line should preserve the
	fontification of the inherited class names.  Analogously for namespace
	names and Java import, extends, etc.

	* cc-fonts.el: (c-make-font-lock-BO-decl-search-function): New function.
	(c-basic-matchers-after - "Fontify the clauses after various keywords"):
	Extract the three keyword lists for the 3 erroneous constructs from the
	list of four, and use the new function above in place of an old one.

2011-08-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-menus.el (cc-imenu-c++-generic-expression): Make it handle function
	pointer parameters properly.

2011-08-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.32

	Use `make-local-hook' only when it's needed.

	* cc-defs.el (c-emacs-features): Add 'add-hook-local into c-emacs-features
	when make-local-hook is required.

	* cc-mode.el (c-basic-common-init, c-font-lock-init): Test c-emacs-features
	for 'add-hook-local.

	* cc-styles.el (c-make-styles-buffer-local): Test c-emacs-features for
	'add-hook-local.


	* cc-defs.el (c-search-forward-char-property):  Streamline by using
	c-next-single-property-change.

	* cc-engine.el:  Correct typos.

2011-08-20  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Resolve invalid use of a regexp in regexp-opt.

	* cc-fonts.el (c-complex-decl-matchers): Add in special detection for a
	java annotation.

	* cc-engine.el (c-forward-decl-or-cast-1): Add in special detection for a
	java annotation.

	* cc-langs.el (c-prefix-spec-kwds-re): Remove the special handling for
	java.
	(c-modifier-kwds): Remove the regexp "@[A-za-z0-9]+".

	* cc-fonts.el: Tidy up font locking of a long CPP construct.

	* cc-fonts.el (c-guess-font-lock-context): eliminate this somewhat pompous
	defun.
	(c-font-lock-complex-decl-prepare): replace a call to the above with
	inline code.


	Fontify CPP expressions correctly when starting in the middle of such a
	construct.  Mainly for when jit-lock etc. starts a chunk here.

	* cc-fonts.el (c-font-lock-context): new buffer local variable.
	(c-make-font-lock-search-form): new function, extracted from
	c-make-font-lock-search-function.
	(c-make-font-lock-search-function): Use the above function.
	(c-make-font-lock-context-search-function): New function.
	(c-cpp-matchers): Enhance the preprocessor expression case with the above
	function
	(c-font-lock-complex-decl-prepare):  Test for being in a CPP form which
	takes an expression.

	* cc-langs.el (c-cpp-expr-intro-re): New lang-variable.

2011-08-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-lt-gt): Remove an unused dynamic variable.


	Reduce the number of compilation warnings:

	* cc-awk.el (c-awk-get-NL-prop-cur-line): Replace `delete-backward-char' by
	`delete-char'.

	* cc-cmds.el (c-electric-lt-gt, c-beginning-of-defun): Remove unused
	dynamic variables.

	* cc-engine.el (top level): Add a cc-bytecomp-defun and a
	cc-bytecomp-defvar.
	(c-ssb-lit-begin, c-forward-<>-arglist-recur):
	(c-just-after-func-arglist-p, c-looking-at-decl-block):
	(c-append-to-state-cache): Remove unused dynamic variables.

	* cc-fonts.el (c-font-lock-enum-tail): Remove an unused dynamic variable.

	* cc-guess.el (top level): Add three cc-bytecomp-defvars.

	* cc-menus.el (cc-imenu-objc-function): Remove an unused dynamic variable.

	* cc-mode.el (top level): Add three cc-bytecomp-defvars.

	* tests/macro-27.cc, tests/macro-27.face, tests/macro-27.res:
	Test "macros with semicolons".

2011-08-15  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Adapt recent changes to work with XEmacs.

	* cc-cmds.el (c-where-wrt-brace-construct): Replace a looking-at with
	a call to c-looking-at-non-alphnumspace, because XEmacs doesn't have
	\s!.
	(c-defun-name): Adapt a regexp not to use \_>.

	* cc-defs.el (c-next-single-property-change): new macro.
	(c-<-as-paren-syntax, c->-as-paren-syntax: Adapt for use as a simple
	value (as well as for category properties).
	(c-put-property-fun, c-put-char-property): wrap in eval-and-compile.
	(c-use-category): new compile-time constant.
	(c-search-forward-char-property):
	(c-clear-char-property-with-value-function):
	(c-clear-char-property-with-value-function, c-mark-<-as-paren):
	(c-mark->-as-paren, c-unmark-<->-as-paren): small changes.
	(c-sc-scan-lists-no-category+1+1, c-sc-scan-lists-no-category+1-1):
	(c-sc-scan-lists-no-category-1-1, c-sc-scan-lists-no-category-1-1):
	(c-sc-scan-lists, c-sc-parse-partial-sexp-no-category):
	(c-sc-parse-partial-sexp): new macrofications of scan-lists and
	parse-partial-sexp, for use in c-parse-state.
	(c-looking-at-non-alphnumspace): new macro.
	(c-emacs-features): Introduce new component category-properties.

	* cc-engine.el (several defuns): Replace next-single-property-change by
	c-next-single-property-change.
	(c-state-cache-non-literal-place): Correct, to avoid the inside of
	macros.
	(c-state-balance-parens-backwards):
	(c-append-lower-brace-pair-to-state-cache, c-state-push-any-brace-pair):
	(c-append-to-state-cache, c-remove-stale-state-cache):
	(c-remove-stale-state-cache-backwards): Replace scan-lists by
	c-sc-scan-lists and parse-partial-sexp by c-sc-parse-partial-sexp.
	(c-invalidate-state-cache, c-parse-state): small changes.
	(c-find-decl-spots): Enhance initialisation of cfd-prop-match to take
	account of a possible c-decl-end c-type property on the last token before
	the region.
	(c-clear-<-pair-props, c-clear->-pair-props): use c-unmark-<->-as-paren.
	(c-before-change-check-<>-operators): Search for syntax-table rather than
	category property.

	* cc-fonts.el (c-skip-comments-and-strings): Use
	c-next-char-propery-change.
	(c-cpp-matchers): Use c-unmark-<->-as-paren.
	(c-font-lock-invalid-string): Use characterp rather than integerp in
	XEmacs, since characters are not integers.

	* cc-mode.el (c-neutralize-syntax-in-and-mark-CPP): Test for category
	properties (i.e. GNU Emacs) before deleting them.
	(c-before-change): replace next-single-property-change by
	c-next-single-property-change.
	(c-after-change): Make an Emacs dependent category property related
	correction dependent on the existence of category properties.

2011-07-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/bitfield-2.c, tests/bitfield-2.face, tests/bitfield-2.res:
	bitfield-2.c: New file to test awkward fontification of bitfields.


	Fontify bitfield declarations properly.

	* cc-langs.el (c-has-bitfields): New lang variable.
	(c-symbol-chars): Now exported as a lang variable.
	(c-not-primitive-type-keywords): New lang variable.

	* cc-fonts.el (c-font-lock-declarations): Jump over the QT keyword "more"
	to prevent "more slots: ...." being spuriously parsed as a bitfield
	declaraion.

	* cc-engine.el (c-beginning-of-statement-1): Refactor and enhance to handle
	bitfield declarations.
	(c-punctuation-in): New function.
	(c-forward-decl-or-cast-1): Enhance CASE 3 to handle bitfield
	declarations properly.

2011-07-22  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Prevent cc-langs.elc being loaded at run time.

	* cc-mode.el: Remove two autoload forms which loaded cc-langs.

	* cc-langs.el (c-make-init-lang-vars-fun): Don't emit "(require 'cc-langs)".
	Quote a form so it will evaluate at (cc-mode's) compilation time.

2011-07-21  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Fontify declarators properly when, e.g., a jit-lock chunk begins inside a
	declaration.

	* cc-langs.el (c-symbol-chars): Correct a typo.

	* cc-fonts.el (c-font-lock-enclosing-decls): New function.
	(c-complex-decl-matchers): Insert reference to
	c-font-lock-enclosing-decls.

	* cc-engine.el (c-backward-single-comment, c-backward-comments): Bind
	open-paren-in-column-0-is-defun-start to nil around calls to
	(forward-comment -1).

2011-07-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-styles.el, Makefile, cc-guess.el, cc-langs.el, cc-mode.el:

	* cc-guess.el: Update this and Make it an integral part of CC Mode.

	* cc-langs.el (c-mode-menu): Added "Style..." submenu.

	* cc-styles.el (cc-choose-style-for-mode): New function derived from
	`c-basic-common-init'.

	* cc-mode.el (top-level): Require cc-guess.  (c-basic-common-init): Use
	`cc-choose-style-for-mode'.

	* cc-mode.texi (Guessing the Style): New page.  (Styles): Add a short
	introduction to above.

	Makefile: Change the position of cc-guess.el.

2011-06-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, tests/templates-19.cc:
	cc-engine (c-guess-continued-construct): Correct the handling of
	template-args-cont, particularly for when font lock is disabled.  Name
	this case as "CASE G".

	templates-19.c: Reindent.

2011-06-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	1: Whilst checking for declarators, disable
	knr checking to speed up for normal files.  2: Refactor, replacing a
	sequence of nested if forms by a cond form.

2011-03-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax):
	Move CASE 19 to a different place, correctly to
	process template-args-cont lines.

2011-02-27  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-continued-construct): In three places, replace
	`lim' with 'containing-sexp'.

	* cc-engine.el (c-guess-continued-construct):
	In three places, replace `paren-state'
	with 'containing-sexp'.


	Fix an infinite loop which happens when a template construct straddles a
	jit-lock boundary.

	* cc-engine.el (c-forward-<>-arglist-recur): recast nested `if's as a
	`cond' form.

	* cc-fonts.el (c-font-lock-declarations): Remove a harmful narrowing to
	region being fontified.

2011-02-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-state-literal-at):
	Prevent positions in macros finding their way into
	c-state-nonlit-pos-cache.  Strengthen the comments.
	(c-state-dump): New commented out diagnostic routine.

	* cc-cmds.el: Eliminate some infinite loops:
	(c-forward-over-illiterls): On encountering a bare '#' step forward over
	it.
	(c-end-of-statement): Set macro-end correctly at the end of a loop.

2010-12-28  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-continued-construct):
	used 'paren-state' instead of 'lim' to fix byte-compile warnings.

2010-12-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-type):
	Before scanning a template arglist, check that the
	current language supports this.

2010-10-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Fix an off-by-1 error.

2010-10-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	Cache the result of the call to
	c-beginning-of-decl-1 inside the internal lambda.  This is for speed.
	(c-font-lock-enum-tail): New function which fontifies the tail of an enum.
	(c-basic-matchers-after): Insert a call to the above new function.

2010-10-24  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Patch to fix templates-19.cc test

2010-10-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-before-change, c-after-change):
	Move the setting of c-new-BEG and
	c-new-END from c-before-change to c-after-change.

2010-10-08  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Together with the previous patch, enhance fontification of declarators to
	take account of the presence/absence of "typedef".

	* cc-engine.el (c-forward-type): New &optional param "brace-block-too".
	(c-forward-decl-or-cast-1): cdr of return value now indicates the
	presence of either or both of a "struct"-like keyword and "typedef".

	* cc-fonts.el (c-complex-decl-matchers): Remove the heuristic fontification
	of declarators which follow a "}".

	* cc-langs.el (c-typedef-kwds c-typedef-key): New lang variable for
	"typedef".
	(c-typedef-decl-key): New lang varaible built from c-typedef-decl-kwds.

	* cc-mode.el (c-advise-fl-for-region): Don't restrict to AWK Mode any more.

2010-10-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	Fontify declarators according to the
	presence/absence of "typedef".

	* tests/class-21.face, tests/decls-33.c, tests/decls-33.face, tests/decls-8.cc, tests/decls-8.face, tests/templates-4.face, tests/typedef-1.face:
	CC Mode now correctly fontifies declarators according to the
	presence/absence of "typedef".  Adapt the test files accordingly.

2010-09-20  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Moved case 19 out of case 7

2010-09-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-<>-arglist-recur): Fix an infinite recursion.

	* cc-engine.el (c-forward-<>-arglist-recur): Correct the indentation.

2010-08-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph, c-fill-paragraph):
	Fix for the case that a C style
	comment has its delimiters alone on their respective lines.

2010-08-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-mode.el, cc-mode.texi, cc-vars.el:
	Eliminate some warning messages when Emacs 23 is used to compile them.

2010-07-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Fix auto-fill bug.

2010-07-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-mode.texi, cc-vars.el, cc-defs.el:
	Integrate java-0-1 branch: Enhance Java Mode to handle Java 5.0 (Tiger)
	and Java 6 (Mustang).  Contributed by Nathanial Flath.

2010-07-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-mode.texi, cc-vars.el, tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	Integrate java-0-1 branch: Enhance Java Mode to handle Java 5.0 (Tiger)
	and Java 6 (Mustang).  Contributed by Nathanial Flath.

2010-07-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/comments-6.c, cc-mode.el:
	Enhance `c-file-style' in file/directory local variables.

	* cc-mode.el (c-count-cfss): New function.
	(c-before-hack-hook): Call `c-set-style' differently according to whether
	c-file-style was set in file or directory local variables.

	tests/comments-6.c.  Enter Emacs-24 as a version in which to ignore this
	test.

2010-07-13  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Fixed chaotic braces in 'Java Symbols'.

2010-06-30  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Added more detail on new syntactic constructs

2010-06-20  Alan Mackenzie  <bug-cc-mode@gnu.org>


	Fix an indentation bug with templates.

	* cc-mode.el (c-common-init): Initialise c-new-BEG/END.
	(c-neutralize-syntax-in-and-mark-CPP): c-new-BEG/END: Take account of
	existing values.

	* cc-engine.el (c-clear-<-pair-props-if-match-after)
	(c-clear->-pair-props-if-match-before): now return t when they've cleared
	properties, nil otherwise.
	(c-before-change-check-<>-operators): Set c-new-beg/end correctly by
	taking account of the existing value.

	* cc-defs.el (c-clear-char-property-with-value-function): Fix this
	to clear the property rather than overwriting it with nil.

	* cc-mode.el (c-before-hack-hook):
	When the mode is set in file local variables, set it
	first.

2010-05-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el, cc-mode.texi, cc-vars.el, cc-cmds.el:
	Amend the handling of c-beginning/end-of-defun in nested declaration
	scopes.

	* cc-vars.el (c-defun-tactic): Move here from cc-langs.el.  Change it to a
	defcustom.

	* cc-mode.texi (Movement Commands): Document `c-defun-tactic'.  Document
	the new handling of nested scopes for movement by defuns.

	* cc-langs.el (c-defun-tactic): Move this variable to cc-vars.el.
	(c-nonlabel-token-2-key): New variable for change in cc-engine.el.

	* cc-engine.el (c-beginning-of-statement-1): Prevent "class foo : bar"
	being spuriously recognized as a label.

	* cc-cmds.el (c-narrow-to-most-enclosing-decl-block): Add parameter
	`inclusive' (to include enclosing braces in the region).
	(c-widen-to-enclosing-decl-scope): New function.
	(c-while-widening-to-decl-block): New macro.
	(c-beginning-of-defun, c-end-of-defun): Change algorithm to keep going
	outward for defun boundaries, and correspondingly change symbol
	`respect-enclosure' to `go-outward'.
	(c-declaration-limits): Change algorithm to report only the "innermost"
	defun's boundaries.

2010-05-25  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Added descriptions of annotation-top-cont and annotation-var-cont into the manual.

2010-05-22  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-mode.el:
	Moved annotation highlighting from java-mode to c-basic-matchers-after.

2010-05-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state-get-strategy): Replace parameter `here' with
	`here-' and `here-+', which sandwich any pertinent CPP construct.

	(c-remove-stale-state-cache-backwards): Fix a bug which happens when
	doing (c-parse-state) in a CPP construct: Exclude any "new" CPP construct
	from taking part in the scanning.

2010-05-21  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/generics-1.face, cc-engine.el:
	Fixed problem where Java Generics were not always fontified.

2010-05-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/generics-1.face, tests/generics-1.java, cc-engine.el:
	Fixed unit tests for template expressions and declarations.  Still a few broken ones in the new unit tests for Java generics.

2010-05-18  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, cc-engine.el:
	Fixed the bugs in annotation highlighting; annotation unit tests are now passing.

	Also reindented c-forward-<>-arglist-recur and made a few changes that fixed some bugs in generic handline, but those unit tests are not entirely passing.

2010-05-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/annotations-1.face:
	file annotations-1.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/annotations-1.java:
	file annotations-1.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/annotations-1.res:
	file annotations-1.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.face:
	file enum-6.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.java:
	file enum-6.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/enum-6.res:
	file enum-6.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.face:
	file foreach.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.java:
	file foreach.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/foreach.res:
	file foreach.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/generics-1.face:
	file generics-1.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/generics-1.java:
	file generics-1.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.face:
	file java-varargs.face was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.java:
	file java-varargs.java was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

	* tests/java-varargs.res:
	file java-varargs.res was added on branch Branch_5_31 on 2010-07-20 20:41:14 +0000

2010-05-17  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-vars.el, tests/000tests.el, tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	Added unit tests for new Java 1.5 constructs, as well as a few bug and formatting fixes.

	Most of the issues brought up by Alan's CR have been fixed, with the
	exception of annotations being font-locked in java-mode.
	Additionally, most of the broken tests were fixed, at the cost of the
	a few of the new unit tests not passing.

	* tests/annotations-1.face, tests/annotations-1.java, tests/annotations-1.res, tests/enum-6.face, tests/enum-6.java, tests/enum-6.res, tests/foreach.face, tests/foreach.java, tests/foreach.res, tests/generics-1.face, tests/generics-1.java, tests/java-varargs.face, tests/java-varargs.java, tests/java-varargs.res:
	New file.

2010-04-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-extend-region-for-CPP):
	Fix an off-by-one error (EO-macro position).

2010-04-28  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el:
	Improved c-forward-annotation to handle annotations with arglists properly.

	* cc-vars.el, cc-engine.el:
	Added two syntactic contexts to support annotations in java.

	The first, annotation-top-cont, represents a topmost continuation where the only items preceding the current line are annotations.  An example is:
	@Test
	_ public void testFoo() {}

	The second is annotation-var-cont, representing a statement continuation where the only preceding items are annotations, such as:
	class Test {
	    public static void main() {
	    @SuppressWarnings
	    _int i;
	    }
	}

2010-04-27  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el: Fixed indentation.

	* cc-engine.el:
	Added support for for:each loops and fixed a few bugs this uncovered in generic highlighting.

2010-04-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el:
	Replace leading spaces by <TAB> characters throughout the source.

	* cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-fonts.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el:
	Replace leading spaces by <TAB>s, synched with java-0-1-merge-3.

	* cc-awk.el, cc-cmds.el, cc-defs.el, cc-engine.el, cc-fix.el, cc-langs.el, cc-lobotomy.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el:
	Replace leading spaces by <TAB> characters throughout source.

	* cc-mode.texi, cc-mode.el, cc-engine.el:
	Merge from Branch_5_31, tag java-0-1-merge-2.

2010-04-24  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el:
	Added correct fontification for Java generics and varargs.

2010-03-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Other Indentation):
	State that functions on c-special-indent-hook are
	called with no parameters and with point on the current line.

2010-03-23  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-mode.el, cc-vars.el:
	Renamed java-annotation-face to c-annotation-face and moved it to cc-fonts.el

2010-03-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache): Fix an off-by-one error.

2010-03-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: *** empty log message ***

	* cc-mode.el:
	Guard against the Emacs core spuriously calling before-change-functions
	twice in succession.
	(c-just-done-before-change): New flag
	(c-before-change): Test and set the new flag before executing anything.
	(c-after-change): Clear the flag.

2010-03-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el, cc-mode.el, tests/inher-5.res, tests/inher-6.res, tests/templates-16.res, tests/templates-5.res, tests/templates-7.res, tests/templates-8.res, cc-cmds.el, cc-defs.el, cc-engine.el:
	Merge from BRANCH_5_31, tag java-0-1-merge-1.

2010-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache):
	Correct the previous patch.

	* cc-engine.el: *** empty log message ***

	* cc-engine.el (c-remove-stale-state-cache):
	Take account of when `good-pos' is in the same
	macro as `here'.

	* cc-engine.el, cc-mode.el: *** empty log message ***



	* cc-mode.el (c-common-init): In the funcall, replace the erroneous `beg',
	`end' with (point-min), (point-max).
	(c-after-change): After (e.g.) C-y, remove the 'syntax-table text props
	that Emacs has converted from 'category text props.

	* cc-engine.el (c-clear-<-pair-props, c-clear->-pair-props): Clear the
	'category text property, not the 'syntax-table one.

2010-02-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-mode.el, cc-vars.el:
	Removed trailing whitespace from cc-vars and cc-engine, and fixed typo (xJava -> Java)

2010-02-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-mode.el: *** empty log message ***



	* cc-mode.el (c-common-init): Use c-get-state-before-change-functions in
	place of c-get-state-before-change-function.  Update some comments about
	this.

	* cc-engine.el: Update some comments about
	c-get-state-before-change-function.

	* cc-cmds.el, cc-defs.el, cc-engine.el, cc-langs.el, cc-mode.el:

	*** empty log message ***


	Change strategy for marking < and > as template delimiters: mark them
	strictly in matching pairs.

	* cc-mode.el (c-before-change): Use c-get-state-before-change-functions.

	* cc-langs.el (c-no-parens-syntax-table): New syntax table, used for
	searching syntactically for matching <s and >s.
	(c-get-state-before-change-functions): New language variable (note the
	plural) which supersedes c-get-state-before-change-function.

	* cc-engine.el (c-clear-<-pair-props, c-clear->-pair-props)
	(c-clear-<>-pair-props, c-clear-<-pair-props-if-match-after)
	(c-clear->-pair-props-if-match-before)
	(c-before-change-check-<>-operators): new functions.
	(c-after-change-check-<>-operators): Use macro c-unmark-<->-as-paren.

	* cc-defs.el (c-search-backward-char-property): New macro.

	* cc-cmds.el (c-electric-lt-gt): Do not set text properties on < and > any
	more.  (These will be handled by font locking.)

2010-01-25  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-vars.el: Highlighting for Java annotation usage

2010-01-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: *** empty log message ***

	* cc-engine.el:
	Fix a situation where deletion of a cpp construct throws an error.
	(c-invalidate-state-cache): Before invoking
	c-with-all-but-one-cpps-commented-out, check that the special cpp
	construct is still in the buffer.
	(c-parse-state): Record the special cpp with markers, not numbers.

	* cc-defs.el: *** empty log message ***

	* cc-defs.el:
	typing '#' in an empty C buffer throws "args out of range".
	(c-set-cpp-delimiters, c-clear-cpp-delimiters): Check for EOB playing the
	role of delimiter.

2010-01-19  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el: Highlight annotations as types

	* cc-mode.el, cc-langs.el: highlighting of @interface in java-mode

2010-01-06  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-menus.el:
	Fixed issue with cc-imenu-java-generic-expression not handling array arguments properly

2009-12-31  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-langs.el:
	Fix for enum indentation in Java.  Aligns all enum options on the same column.

	* cc-langs.el: Added proper highlighting for java enums

2009-12-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/templates-19.cc, tests/templates-19.res:
	Test template use in statements when the templates span line breaks.

	* tests/inher-5.res, tests/inher-6.res, tests/templates-16.res, tests/templates-5.res, tests/templates-7.res, tests/templates-8.res:
	Amend for the second anchor point just added to template-args-cont.


	Handle templates continued over line breaks in statements.  Refactor
	c-syntactic-skip-backward.  Make text property `category' rear
	non-sticky.

	* cc-mode.el (c-basic-common-init): make text property `category' rear
	non-sticky.

	* cc-engine.el (c-ssb-lit-begin): New defsubst, extracted from ....
	(c-syntactic-skip-backward): Refactor, extracting the above.
	(c-guess-basic-syntax CASEs 5D.3, 5L): Add extra anchor point;
	(c-guess-basic-syntax CASE 19): New CASE to handle template
	construct continued over line boundary.
	(c-guess-basic-syntax CASE 7): don't trigger on '<'.

2009-12-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhance `c-parse-state' to run efficiently in "brace desserts".
	 cc-mode.el (c-basic-common-init): Call c-state-cache-init.
	(c-neutralize-syntax-in-and-mark-CPP):  Renamed from
	c-extend-and-neutralize-syntax-in-CPP.  Mark each CPP construct by
	placing `category' properties value 'c-cpp-delimiter at its
	boundaries.

	* cc-langs.el (c-before-font-lock-function):
	c-extend-and-neutralize-syntax-in-CPP has been renamed
	c-neutralize-syntax-in-and-mark-CPP.

	* cc-fonts.el (c-cpp-matchers): Mark template brackets with
	`category' properties now, not `syntax-table' ones.

	* cc-engine.el (c-syntactic-end-of-macro): A new enhanced (but
	slower) version of c-end-of-macro that won't land inside a literal
	or on another awkward character.
	(c-state-cache-too-far, c-state-cache-start)
	(c-state-nonlit-pos-interval, c-state-nonlit-pos-cache)
	(c-state-nonlit-pos-cache-limit, c-state-point-min)
	(c-state-point-min-lit-type, c-state-point-min-lit-start)
	(c-state-min-scan-pos, c-state-brace-pair-desert)
	(c-state-old-cpp-beg, c-state-old-cpp-end): New constants and
	buffer local variables.
	(c-state-literal-at, c-state-lit-beg)
	(c-state-cache-non-literal-place, c-state-get-min-scan-pos)
	(c-state-mark-point-min-literal, c-state-cache-top-lparen)
	(c-state-cache-top-paren, c-state-cache-after-top-paren)
	(c-get-cache-scan-pos, c-get-fallback-scan-pos)
	(c-state-balance-parens-backwards, c-parse-state-get-strategy)
	(c-renarrow-state-cache)
	(c-append-lower-brace-pair-to-state-cache)
	(c-state-push-any-brace-pair, c-append-to-state-cache)
	(c-remove-stale-state-cache)
	(c-remove-stale-state-cache-backwards, c-state-cache-init)
	(c-invalidate-state-cache-1, c-parse-state-1)
	(c-invalidate-state-cache): New defuns/defmacros/defsubsts.
	(c-parse-state): Enhanced and refactored.
	(c-debug-parse-state): Amended to deal with all the new
	variables.

	* cc-defs.el (c-<-as-paren-syntax, c-mark-<-as-paren)
	(c->-as-paren-syntax, c-mark->-as-paren, c-unmark-<->-as-paren):
	modify to use category text properties rather than syntax-table
	ones.
	(c-suppress-<->-as-parens, c-restore-<->-as-parens): new defsubsts
	to switch off/on the syntactic paren property of C++ template
	delimiters using the category property.
	(c-with-<->-as-parens-suppressed): Macro to invoke code with
	template delims suppressed.
	(c-cpp-delimiter, c-set-cpp-delimiters, c-clear-cpp-delimiters):
	New constant/macros which apply category properties to the start
	and end of preprocessor constructs.
	(c-comment-out-cpps, c-uncomment-out-cpps): defsubsts which
	"comment out" the syntactic value of characters in preprocessor
	constructs.
	(c-with-cpps-commented-out)
	(c-with-all-but-one-cpps-commented-out): Macros to invoke code
	with characters in all or all but one preprocessor constructs
	"commented out".

2009-11-23  Nathaniel Flath  <bug-cc-mode@gnu.org>

	* cc-menus.el:
	Updating cc-imenu-java-generic-expression in order to match Java1.6 methods with generics and annotations.

2009-09-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-nonlabel-token-key): Allow quoted character constants (as
	case labels).

	* cc-engine.el (c-beginning-of-statement-1): Correct buggy bracketing.

2009-09-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-scan-conditionals):
	A new function like c-forward-conditionals, but it
	doesn't move point and doesn't set the mark.
	(c-up-conditional, c-up-conditional-with-else, c-down-conditional)
	(c-down-conditional-with-else, c-backward-conditional)
	(c-forward-conditional): Refactor to use c-scan-conditionals.

	* cc-bytecomp.el (cc-bytecomp-ignore-obsolete):
	In Emacs 23, byte-compile-warnings isn't
	always a list any more.  Use new function byte-compile-disable-warning
	here.

2009-08-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php:
	Update and clarify the current status of the 5.31.n releases.

	* cc-defs.el (c-version):
	increment the version number to 5.31.8.prerelease.

2009-07-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-mode.texi:
	Whilst initialising a mode, make any explicit setting of a variable take
	precedence over one done via c-file-style/c-file-offsets.

	* cc-mode.el (c-before-hack-hook, c-postprocess-file-styles): give
	c-set-style a DONT-OVERRIDE parameter of t in each function.

	* cc-mode.texi (Config Basics, File Styles): Amend documentation.

2009-06-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph):
	Remove a spurious correction between the visible
	width of TABs and their number of bytes, so that point is undisturbed
	after typing a space, when there are tabs just before "*/".

2009-06-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce "font lock contexts", to enable (in particular) jit-lock to fontify
	correctly when starting in the middle of a construct.  Implement this for CPP
	expressions.

	* cc-langs.el (c-cpp-expr-intro-re): New variable.

	* cc-fonts.el (c-guess-font-lock-context): New function.
	(c-font-lock-context): New buffer local variable.
	(c-make-font-lock-search-form): New function, extracted from
	c-make-font-lock-search-function.
	(c-make-font-lock-search-function): Use the above function.
	(c-make-font-lock-context-search-function): New function.
	(c-cpp-matchers): Enhance the preprocessor expression case as above.
	(c-font-lock-complex-decl-prepare): Call c-guess-font-lock-context.

2009-05-21  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-langs.el (c-before-font-lock-function): Change the name of an entry
	to c-extend-and-neutralize-syntax-in-CPP.

	* cc-mode.el (c-basic-common-init): Set
	font-lock-extend-after-change-region-function to
	c-extend-after-change-region for Emacs 22 and later.
	(c-before-hack-hook): Correct "hack-local-variables-alist" to
	"file-local-variables-alist".
	(c-extend-and-neutralize-syntax-in-CPP): Renamed from
	c-neutralize-syntax-in-CPP; it now extends the font lock region by
	setting c-new-BEG and c-new-END.
	(c-font-lock-init): Remove initialization of obsolete variable
	font-lock-lines-before.
	(c-extend-after-change-region): New function.
	(c-advise-fl-for-region): Generated code now extends f-l region for any
	CC Mode, not just AWK Mode.

	* cc-fonts.el, cc-engine.el:
	Undo the last change, which was ill thought out, apart from the macro
	c-search-forward-char-property and some enhancements to comments.

2009-05-18  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-fonts.el (c-font-lock-invalid-cpp-string-matcher): New function.

	(c-basic-matchers-before): New clause to fontify invalid strings in a CPP
	construct.

	* cc-engine.el: Update some commenting.

	* cc-defs.el (c-search-forward-char-property): new macro.

2009-04-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Enhancements for Objective-C:

	* cc-vars.el: (c-objc-method-arg-min-delta-to-bracket,
	c-objc-method-arg-unfinished-offset, c-objc-method-parameter-offset): New
	variables.
	(c-offsets-alist): Use c-lineup-ObjC-method-call-colons in entry for
	objc-method-call-cont.

	* cc-langs.el: (c-constant-kwds): New ObjC keywords "YES", "NO",
	"NS_DURING", "NS_HANDLER", "NS_ENDHANDLER".

	* cc-align.el: (c-lineup-ObjC-method-call-colons): New function.

	* cc-menus.el: (cc-imenu-objc-function): Remove calls of
	imenu-progress-message.

2009-03-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-engine.el, cc-fonts.el, cc-langs.el, cc-mode.texi, cc-vars.el:
	Amend to indent and fontify macros "which include their own semicolon"
	correctly, using the "virtual semicolon" mechanism.

	* cc-defs.el: Update "virtual semicolon" comments.

	* cc-engine.el (c-crosses-statement-barrier-p): Recoded to scan one line at
	at time rather than having \n and \r explicitly in c-stmt-delim-chars
	(for some modes, e.g. AWK).
	(c-forward-label): Amend for virtual semicolons.
	(c-at-macro-vsemi-p, c-macro-vsemi-status-unknown-p): New functions

	* cc-fonts.el (c-font-lock-declarations): Take account of the new C macros.

	* cc-langs.el (c-at-vsemi-p-fn, c-vsemi-status-unknown-p-fn): move to
	earlier in the file.
	(c-opt-cpp-symbol, c-line-comment-start-regexp): New language variables.
	(c-opt-cpp-macro-define): Make into a full language variable.
	(c-stmt-delim-chars, c-stmt-delim-chars-with-comma): Special value for
	AWK Mode (including \n, \r) removed, no longer needed.

	* cc-mode.el (c-mode, c++-mode, objc-mode): Invoke
	c-make-macro-with-semi-re.  (Erroneously committed early, in previous
	version, 5.259.)

	* cc-vars.el (c-macro-with-semi-re, c-macro-names-with-semicolon): New
	variables.
	(c-make-macro-with-semi-re): New function

	* cc-mode.texi (Indentation Commands): Mention "macros with semicolons".
	(Other Special Indentations): Add an xref to "Macros with ;".
	(Customizing Macros): Add stuff about syntax in macros.  Add an xref to
	"Macros with ;".
	(Macros with ;): New page.

2009-02-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el:
	Allow (compile time) expressions in case clauses.

	* tests/switch-16.c, tests/switch-16.res: New file.

	* tests/switch-16.c, tests/switch-16.res:
	Test files for "case <expression>:".

2009-02-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-defun-name): Widen, so it works on a narrowed region.

2009-02-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features):
	Check the working of beginning/end-of-defun-function
	more rigorously before setting argumentative-bod-function.

2009-01-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-setup-paragraph-variables):
	Ensure paragraph-\(start\|separate\) match
	blank lines.  For AWK Mode.

2008-11-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/000tests.el (cc-test-extend-faces):
	When two faces aren't distinct, display a
	`message' rather than throwing an `error', a barely understood kludge to
	allow interactive use of 000tests.el.

	(do-all-tests): reset buffer *cc-test-log* to read/write after calling
	`compilation-mode'.

	* tests/top-4.res, tests/statement-15.res, tests/macro-8.res, tests/macro-7.res, tests/macro-3.res, tests/comments-4.res, tests/bracelist-11.res, tests/access-labels-qt-1.res:
	Correct the syntactical analysis of subsequent macro continuation lines.
	They are now never 'cpp-define-intro'.

2008-11-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-label):
	Handle the new QT macros Q_SLOTS and Q_SIGNALS.

2008-10-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-recognize-<>-arglists):
	Enable this, crudely, for java.  This will
	enable certain constructs with generics to be recognized, although it
	won't correctly handle the general use of generics.

2008-10-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-defun-name):
	Make it work for "struct foo bar [] = { ...".

2008-10-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-region):
	Fix previous patch so that the function works on
	one-line macros.

2008-10-07  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-before-hack-hook):
	New hook function for new hook (in Emacs 23)
	(top level): Use this new hook if it's there, otherwise use
	hack-local-variables-hook.

	* cc-mode.el (c-mode-base-map):
	Don't bind C-m-[ae] to c-{beginning,end}-of-defun when
	the current Emacs version passes a parameter to
	{beginning,end}-of-defun-function.

	* cc-engine.el (c-literal-type, c-forward-decl-or-cast-1, c-at-toplevel-p):
	Amend doc
	strings.
	(c-forward-decl-or-cast-1): Add in comments like "CASE 1", "CASE 2", ...
	which will later (hopefully) be fleshed out with detailed comments.

	* cc-cmds.el (c-indent-region):
	Fix so that indenting a macro followed by blank lines
	doesn't backslash the following non-blank line into the macro.

	* cc-align.el (c-lineup-respect-col-0): New function.

	* cc-styles.el (c-style-alist "ellemtel"):
	Move arglist-cont-nonempty into
	c-hanging-braces-alist.
	Change some `mapcar's into `mapc's.

2008-10-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cvstest.txt: Initial commision.

	* cvstest.txt: New file.

2008-10-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): For "if (a<0 || b>99)", set
	c-restricted-<>-arglists to t, so that the innards aren't treated as a
	template bracket enclosure.  Also refactor the code here.

2008-08-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features):
	set `argumentative-bod-function' when the Emacs core
	passes ARG through to `beginning-of-defun-function'.

2008-06-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Improve the doc string.

	* cc-langs.el (c-defun-tactic): New language variable defining BO-defun.
	(This was already being used, although not defined.)

	* cc-cmds.el (c-where-wrt-brace-construct): Fix problem with "labels" (e.g.
	"private:") at the top level.

2008-06-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax CASE 5D.5):
	Fix an infinite loop on invalid syntax.

2008-05-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-postprocess-file-styles):
	Throw an error if c-file-style is set to a
	non-string.
	(c-neutralize-syntax-in-CPP): Optimize for speed.

2008-05-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax, CASE 5B.1):
	Fix off-by-1 error, comparing position
	of ':' with BOL.

2008-05-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Class Symbols): Correct a typo.

	* cc-fonts.el (c-font-lock-declarations):
	In "if (Bool *b = f())", fontify "Bool" as a
	type.
	Also enhance the commenting significantly.

2008-04-17  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-langs.el (c-type-decl-prefix-key): C++ bit: move
	"\(const\|throw\|volatile\)\>" nearer the start of the regexp, so that
	these keywords aren't wrongly matched as identifiers.

	* cc-fonts.el (c-font-lock-declarators): In (match-beginning 2), "2" ->
	"3", corresponding to the change in c-type-decl-prefix-key.
	(c-font-lock-maybe-decl-faces): Rearranged the header comments.

	* cc-engine.el (c-find-decl-spots): Rearranged the header comments.
	(c-forward-decl-or-cast-1): (i) In (match-beginning 2), "2" -> "3",
	corresponding to the change in c-type-decl-prefix-key.  (ii) Remove a
	check for a semicolon at the end of a function declaration: this causes
	C++ constructor declarations to be fontified before the semicolon is
	typed.

	* cc-defs.el (c-version): increment the version number to 5.31.6.

2008-04-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-modified-constant): new language constant:  matches, e.g.
	"L'a'".

	* cc-engine.el (c-beginning-of-statement-1): modify to handle "case L'a':".

	* cc-fonts.el (c-font-lock-complex-decl-prepare):
	Remove (most) c-type properties also
	from the last token _before_ the (font-lock) region, not just those
	actually inside it.

	Enhance some of the commenting.

2008-04-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php, admin/compat.php, admin/index.php, admin/lists.php, admin/release.php:
	Update to current admin state.

2008-04-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (c-offsets-alist):
	Correct typos ("c-set-offsets" -> "c-set-offset",
	twice).

2008-04-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-before-font-lock-function):
	Correct a typo in the doc string.

2008-04-05  Alan Mackenzie  <bug-cc-mode@gnu.org>


	* cc-engine.el, cc-mode.texi:


	* cc-cmds.el (c-defun-name, c-cpp-define-name): New commands, primarily to
	support (X)Emacs's C-x 4 a (`add-change-log-entry-other-window') and
	friends.

	* cc-langs.el (c-opt-cpp-macro-define-start): Add a regexp submatch to
	match the #define's name.

	* cc-mode.el (c-neutralize-syntax-in-CPP):
	Remove a superfluous right parenthesis.

	* cc-mode.texi, cc-engine.el:

	* cc-engine.el (c-in-knr-argdecl): In a suspected K&R region, scan at most
	20 brace/paren pairs.  This prevents a drastic slowdown in files (e.g.
	Emacs's lisp.h) where there are many consecutive declarations without a
	brace block.

	* cc-mode.texi ("Limitations and Known Bugs") Document this restriction.

	* cc-vars.el (c-constant-symbol):
	put `save-excursion' round this function.

2008-03-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-neutralize-syntax-in-CPP): Fix coding bug.

	* cc-langs.el (c-before-font-lock-function):
	Fix bug in doc-string, "c-old-LEN" ->
	"c-old-END".

2008-02-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-neutralize-syntax-in-CPP):
	Fix a bug on typing "#" at EOB.

2008-02-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Set of changes so that "obtrusive" syntactic elements in a C/C++/ObjC
	preprocessor line (e.g. an unbalanced string quote or unmatched paren) don't
	interact syntactically with stuff outside the CPP line.

	* cc-awk.el (c-awk-beyond-logical-line, c-awk-old-ByLL): Replace
	c-awk-end-of-logical-line and c-awk-old-EoLL to solve an off-by-one bug.

	(c-awk-record-region-clear-NL): Replaces c-awk-before-change, with a bit
	of refactoring.

	(c-awk-extend-and-syntax-tablify-region): Takes some of the functionality
	of c-awk-advise-fl-for-awk-region, which has been refactored away.

	* cc-defs.el (c-clear-char-property-with-value-function)
	(c-clear-char-property-with-value): New function and macro which remove
	text-properties `equal' to a supplied value.

	* cc-engine.el: Comment about text properties amended.

	* cc-fonts.el (c-cpp-matchers): Make it put regexp parens around
	"error\\|warning".

	* cc-langs.el (c-get-state-before-change-function)
	(c-before-font-lock-function, c-anchored-cpp-prefix): New language
	variables.
	(c-cpp-message-directives): Handle "#warning" in C, C++ and ObjC.

	* cc-mode.el (c-basic-common-init): C and ObjC now use
	syntax-table text properties.
	(c-common-init): Call language specific before/after-change functions at
	mode initialisation.
	(c-new-BEG, c-new-END, c-old-BOM, c-old-EOM): New variables.
	(c-extend-region-for-CPP, c-neutralize-CPP-line)
	(c-neutralize-syntax-in-CPP): New functions.
	(c-before-change, c-after-change): Call the new language specific change
	functions defined in cc-langs.el.
	(c-advise-fl-for-region): New macro.
	(awk-mode): Remove AWK specific stuff which has been refactored into
	language independent stuff.

2008-02-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-specifier-key):
	Exclude "template" from this regexp; to anchor the "{" of a
	template function correctly on "template", not the following "<".

	* cc-engine.el (c-guess-basic-syntax, CASE 5A.5):
	Anchor the "{" of a template function
	correctly on "template", not the following "<".

	(c-guess-basic-syntax, CASE 5H): prevent a macro call inside a struct
	being recognised as a K&R argument.

	* cc-align.el, cc-awk.el, cc-cmds.el, cc-defs.el, cc-styles.el:
	Correct typos, remove WS, rephrase doc-strings/comments a little.

2008-01-26  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-save-buffer-state):
	Bind buffer-file-name and buffer-file-truename to
	nil, to prevent primitives generating "buffer is read only" messages.

2008-01-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el (defcustom-c-stylevar):
	New version by Thien-Thi Nguyen which gets rid of
	ugly nested backquotes.

	* tests/000tests.el (do-all-tests, do-one-test):
	bind 'enable-local-variables so as to get
	round GNU Emacs's tighter restrictions on file local variables.

	* cc-awk.el:
	awk-escaped-nls*: Use eval-and-compile to avoid compilation error.

2007-11-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php: Explain about version 5.31.4.

2007-09-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/links.h:
	At an extra link to directory "manual".  Rename "Documentation" to
	"Manual", clarifying with "(html)" and "(info/PS/DVI)".

2007-08-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	With two "namespace"s on the same line, the next line's syntactic context
	(i) gets 2 "innamespace" elements, not 1 defun-block-intro + 1
	innamespace;
	(ii) the anchor points are now those of the namespace constructs, not
	just the line's indentation.

	* cc-langs.el (c-other-decl-block-key-in-symbols-alist): a new language
	variable, an alist with elements like ("namespace" . innamespace).

	* cc-engine.el (c-brace-anchor-point): New function.  (c-add-stmt-syntax):
	Give accurate anchor points for "namespace", "extern" etc., rather than
	BOI.  Fix addition of spurious syntactic-symbol 'defun-block-intro,
	replacing it with 'innamespace, etc.

2007-08-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Mailing Lists and Bug Reports": correct "-no-site-file" to
	"--no-site-file".

2007-07-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-mode.el:
	Move macro call `c-make-emacs-variables-local' from
	c-init-language-vars-for to c-make-init-lang-vars-fun, so that it works
	for derived modes.

2007-07-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Makefile:
	Rename target "html" to "html-raw".  New "html" fixes up links to the
	Emacs/Elisp manuals, pointing them into http://www.gnu.org.

	* 2www.gnu.org.sh: Add a #! line, and a directory parameter.

2007-07-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* 2www.gnu.org.sh:
	The manual has cross references to the Emacs and Elisp manuals.  In the
	HTML manual, these became broken links.  This script directs those links
	to the right places in http://www.gnu.org.  (It also removes a link to a
	manual which doesn't seem to exist online.)

2007-07-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/access-labels-qt-1.face, tests/class-1.face, tests/class-23.face, tests/class-4.face, tests/class-9.face, tests/interface-1.face, tests/switch-1.face, tests/switch-10.face, tests/switch-12.face, tests/switch-14.face, tests/switch-15.face, tests/switch-3.face, tests/templates-1.face, tests/templates-2.face, tests/templates-3.face, tests/templates-4.face, tests/templates-6.face, tests/union-2.face:
	Update 18 files.face to reflect the change in cc-fonts.el
	V5.205.2.4/5.209: Keywords which are terminated by a colon (e.g.
	default:, public:) and the analogous Objective-C keywords are now
	fontified with font-lock-keyword-face.

2007-07-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-version):
	Increase to 5.31.5.  (5.31.4 was the version in Emacs 22.1.)

2007-07-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el:
	Repair the customization routines which handle alists so that it is
	possible to insert entries for those keys which are valid, yet aren't
	currently in the alist.

	(c-constant-symbol): New defun which supersedes c-const-symbol.
	(c-indent-comment-alist, c-hanging-braces-alist, c-hanging-colons-alist,
	c-offsets-alist): Replace c-const-symbol by c-constant-symbol.

	Make the syntactic symbol arglist-cont-nonempty a legitimate key in
	c-hanging-braces-alist.

	* cc-cmds (c-brace-newlines): Amend.

	* cc-styles.el (c-style-alist): Extend all standard styles to include the
	new element.

	* cc-vars.el (c-hanging-braces-alist): Amend the default value, and the
	customization form.

	* cc-mode.el: c-before-change: Replace a "1" with "(point-min)".

	* cc-cmds.el, cc-mode.el: cc-cmds.el (c-electric-slash):

	* cc-mode.el (c-remove-any-local-eval-or-mode-variables):
	Replace wrong uses of `kill-...' (which added spurious entries to the
	kill ring) by `delete-....'.

	* cc-cmds.el (c-in-function-trailer-p):
	Fix this: when a function return type contains
	"struct", "union", etc.  c-end-of-defun goes too far forward.

	* cc-subword.el (c-capitalize-subword):
	More closely mimic the behavior of `capitalize-word'.
	Do not move point with a negative argument.  Based on tiny change by Paul
	Curry.

	* cc-subword.el (c-downcase-subword, c-upcase-subword):
	Don't move point if ARG is
	negative.  Patch by Paul Curry.

	Changes to make `narrow-to-defun' and `mark-defun' work properly
	in CC Mode:

	* cc-defs.el (c-beginning-of-defun-1):

	* cc-cmds.el (c-beginning-of-defun, c-end-of-defun):
	Bind beginning/end-of-defun-function to nil around calls to
	beginning/end-of-defun.

	* cc-langs.el (beginning-of-defun-function,
	end-of-defun-function): New c-lang-setvar's.

	* cc-awk.el (c-awk-beginning-of-defun): Add "(or arg
	(setq arg 1))" to enable non-interactive call.

	* cc-cmds.el (c-end-of-defun):
	Tidy up, to eliminate byte-compiler warning "value
	unused" in Emacs 22.

2007-07-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-paren):
	Fix space-before-funcall clean-up: only insert space
	when on identifier, etc.  Patch by David Hansen.

	Fix fontification of labels, and other things with ":".

	* cc-engine.el (c-forward-label): The function now
	returns 'goto-target, 'qt-2kwds-colon, 'qt-1kwd-colon, as well as the
	former t.

	* cc-fonts.el (c-font-lock-declarations): Interpret the
	new return code from c-forward-label, fontifying tokens properly.  Add
	some general comments throughout the file.

	* cc-vars.el (c-special-indent-hook): Amend doc-string to mention
	c-syntactic-indentation.

	* cc-cmds.el (c-forward-to-nth-EOF-}): Fix EOB bug.

	* cc-mode.el (c-make-emacs-variables-local):
	Use `mapcar' rather than `mapcan' to
	silence compiler warning in GNU Emacs 22.

	Remove stale tokens from `c-found-types' cache.

	* cc-engine.el: (c-partial-ws-p, c-unfind-type, c-trim-found-types): New
	functions.

	* cc-mode.el:  (c-unfind-enclosing-token, c-unfind-coalesced-tokens,
	c-before-change): New functions.  (c-maybe-stale-found-type): New
	variable.

2007-06-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/lists.php: Update the address of the cc-mode-help mailing list.

2007-03-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:

	* cc-styles.el: cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.


	* cc-align.el: Correct a logistical error in the previous patch.

	* cc-align.el: cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.

	* cc-compat.el, cc-langs.el, cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el:
	Update the copyright statements, correct some typos, remove silly WS,
	improve a few comments.

2007-02-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-menus.el, cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el, cc-compat.el, cc-langs.el:
	Update the copyright statements, correct some typos, remove silly WS,
	improve a few comments.

	* cc-mode.texi: Correct lots of typos.
	("Getting Started"): Change a sentence to the conditional.
	("Movement Commands"): Add missing (@code{c-beginning/end-of defun}).
	("Clean-ups"): Add an example for inserting a clean-up into
	c-cleanup-list.

	* cc-mode.el (c-basic-comment-init):
	Don't set open-paren-in-column-0-is-defun-start
	to nil any more.  Discussion in emacs-devel showed this was
	counter-productive.

	* cc-fonts.el: Added comments to c-font-lock-complex-decl-prepare,
	c-font-lock-<>-arglists, c-font-lock-declarations, c-font-lock-c++-new,
	explaining that they get called as font-lock "FUNCTION"s; to
	c-font-lock-declarations (a c-lang-defconst) explaining that it dumps
	these functions to c-matchers-3.

	* cc-engine.el (c-beginning-of-current-token):
	For no movement, return NIL, not 0.
	(c-in-knr-argdecl): Fixed, so that it doesn't get confused by "[]" when
	doing a C-M-a.

	* cc-defs.el (c-go-list-forward, c-go-list-backward): New macros.

	* cc-cmds.el (c-where-wrt-brace-construct):
	correct the handline of K&R regions; C-M-a
	was fouling up in them.
	(c-indent-line): Change the notion of "whitespace" used for <tab>, so
	that a ^L doesn't get swallowed.
	(c-mask-paragraph): Correct the handling of unclosed C-style comments,
	(for when auto-fill-mode is enabled).
	(c-indent-new-comment-line): With M-j in an empty C-style comment,
	correct the final position of point.

2006-11-12  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Fix clean-up space-before-funcall so that it doesn't split the identifer
	from the parentheses in "#define foo(..)".

	* cc-langs.el (c-opt-cpp-macro-define-id): new language variable.

	* cc-engine.el (c-forward-over-cpp-define-id): new function.

	* cc-cmds.el (c-electric-paren): Amend the function.

2006-11-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* README: Tell XEmacs users they need the "advice" package.

	* tests/access-labels-qt-1.res, tests/bracelist-11.res, tests/comments-4.res, tests/macro-3.res, tests/macro-7.res, tests/macro-8.res, tests/statement-15.res, tests/top-4.res:
	Correct the syntactical analysis of subsequent macro continuation lines.
	They are now never 'cpp-define-intro'.

	* tests/macro-23.c, tests/macro-23.res: New file.

	* tests/macro-23.c, tests/macro-23.res:
	New test case for plain statements as the continuation lines of a macro.

	* tests/macro-27.c, tests/macro-27.res:
	A new test case for a wierd mixture of invalid syntax with CPP, labels,
	and an escaped newline.

	* tests/macro-27.c, tests/macro-27.res: New file.

	* cc-engine.el:
	(i) (c-guess-basic-syntax, case 5N): Check the format of c-state-cache is
	valid for an optimisation before using it.
	(ii) (c-guess-basic-syntax): New case 5Q "we are at a statement within a
	macro".  Other changes so that only the first continuation line in a
	macro gets the symbol `cpp-define-intro', the others get `statement', or
	whatever.

	* cc-mode.texi ("Limitations and Known Bugs"):
	Document problems with eval-after-load
	and a workaround.

2006-07-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	Introduce macro c-lang-setvar (sister to c-lang-defvar) to set standard
	Emacs variables (like comment-start) to language dependent values, yet
	without spuriously "defvar"ing them.

	* cc-langs.el (c-emacs-variable-inits): new variable.
	(c-lang-setvar): new macro.
	(c-make-init-lang-vars-fun): Use the initialization forms in
	c-emacs-variable-inits in addition to those in c-lang-variable-inits.
	(comment-start, comment-end, comment-start-skip): Change these from
	c-lang-defvar's to c-lang-setvar's

	* cc-mode.el (c-make-emacs-variables-local): new macro, which calls
	make-local-variable on the elements of c-emacs-variable-inits.
	(c-init-language-vars-for): Call this macro.

2006-07-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-mode.texi:

	* cc-mode.texi ("Filling and Breaking"): Amend the doc for
	c-context-line-break.

	* cc-mode.texi, cc-cmds.el:

	* cc-cmds.el (c-context-line-break): When invoked within a string, preserve
	whitespace.  Add a backslash only when also in a macro.

	* cc-mode.texi ("Filling and Breaking"): Amend the doc for
	c-context-line-breaak.

2006-07-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el: cc-defs.el.  Correct typos.


	* cc-awk.el, cc-fonts.el: Move awk-font-lock-keywords from cc-fonts.el back
	to cc-awk.el to eradicate an eval-after-load, at the request of RMS.

2006-07-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-context-line-break): don't indent the new line after an
	escaped EOL in a string.

2006-07-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/label-10.c, tests/label-10.res:
	label-10.{c,res}: Recognise "foo:" as a label when it directly follows "else",
	"do", ....

	* tests/label-10.c, tests/label-10.c~, tests/label-10.res: New file.

	* tests/label-10.c, tests/label-10.c~, tests/label-10.res:
	label-10.{c,res}: Recognise "foo:" as a label when it directly follows "else",
	"do", ....

	* cc-engine.el (c-forward-label): Recognise "foo:" as a label when it
	directly follows "else", "do", ....

2006-07-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/templates-18.cc, tests/templates-18.res: New file.

	* tests/templates-18.cc, tests/templates-18.res:
	templates-18.{cc,res}: tolerate empty angle brackets (as
	seen in "explicit specialisations" of templates).


	* cc-engine.el (c-looking-at-decl-block): tolerate empty angle brackets (as
	seen in "explicit specialisations" of templates).

2006-05-16  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php, admin/links.h:
	Update the CVS server name to "cc-mode.cvs.sourceforge.net".

	* admin/anoncvs.php, admin/links.h:
	Update the CVS server to "cc-mode.cvs.sourceforge.net".

2006-05-14  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/anoncvs.php:
	Update the CVS host (following a SourceForge upgrade).

2006-04-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-vars.el:

	* cc-vars.el (c-indentation-style): Mention c-file-style in the doc-string.

	* cc-mode.texi ("Choosing a Style"): Mention c-file-style.


	* cc-cmds.el (c-mask-paragraph): Fix for C comments, when the comment ender
	looks like "=========*/" and is alone on its line.


	* cc-langs.el, cc-engine.el: Correct the spelling of
	c-opt-op-identiTier-prefix, t -> f.  Leave an alias for the old name.

	* cc-mode.texi, cc-mode.el:

	* cc-mode.el: Bind C-M-a and C-M-e to c-\(beginning\|end\)-of-defun by
	default.

	* cc-mode.texi ("Movement Commands", "Sample .emacs File"): Document this.


	* cc-align.el, cc-styles.el: New line-up function,
	c-lineup-gnu-DEFUN-intro-cont, for the DEFUN macro in the Emacs C
	sources.  Only used in "gnu" style.

2006-04-14  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/release.php:
	Correct a link from http://download.sourceforge.net/.... to
	http://PRdownloadS.sourceforge.net/...

	* cc-cmds.el (c-electric-slash):
	Extend the handling of clean-up comment-close-slash
	also to work when there's a comment terminator on the line.
	(c-beginning-of-defun, c-end-of-defun): Refactor and optimise these for
	large arg - only take account of top level {..}, except for initial and
	final adjustments.  M-- C-M-[ae] now go to the right defuns when the
	starting point is between defuns.  They use the four new functions:
	(c-in-function-trailer-p, c-where-wrt-brace-construct,
	c-backward-to-nth-BOF-{, c-forward-to-nth-EOF-}): new functions to
	support c-\(beginning\|end\)-of-defun.

	* cc-engine.el (c-forward-label):
	Analyze ":" expressions more rigorously, to exclude
	bit-field specifiers from being classed as labels.
	(c-forward-label): When analyzing a ":" within a macro, be careful about
	using c-forward-syntactic-ws at the macro beginning.
	(c-beginning-of-decl-1): Whilst searching for "=" as evidence of a stmt
	boundary, check for "operator=", etc.

2006-04-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* tests/access-labels-qt-1.cc, tests/access-labels-qt-1.face, tests/access-labels-qt-1.res:
	Jazz up the QT "slots:" declarations by inserting comments and macros
	into them.

	* cc-mode.texi ("Other Commands"):
	Move c-set-style (C-c .) here from "Choosing a
	Style".
	("Styles"): Add @dfn{style}.

	* Makefile (docs: target):
	Add a line to build cc-mode.XEMACS.info.tar.gz.

	* ChangeLog: Correct a typo.

2006-02-19  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features): Don't assume point-min==1.

	* NEWS, cc-cmds.el, cc-mode.el, cc-mode.texi:
	Rename c-hungry-backspace to c-hungry-delete-backwards, at the request of
	RMS.  Leave the old name as an alias.

	* cc-awk.el: Correct a typo.

	* admin/changes-531.php:
	Rename c-hungry-backspace to c-hungry-delete-backwards, at the request of
	RMS.  Leave the old name as an alias.

	* cc-mode.texi:
	(i) Correct the definition of c-beginning-of-defun, to include the
	function header within the defun.
	(ii) Two minor amendments from Savannah.

	* cc-fix.el:
	In the test for a broken (XEmacs) font-lock-compile-keywords, exclude GNU
	Emacs, whose CVS version would now signal an error.

	* cc-fix.el, cc-guess.el, cc-lobotomy.el, cc-styles.el, cc-subword.el, cc-vars.el, cc-align.el, cc-awk.el, cc-bytecomp.el, cc-cmds.el, cc-compat.el, cc-defs.el, cc-engine.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el:
	(i) Add 2006 to the copyright statement.
	(ii) Correct a typo in cc-mode.el.

	* cc-mode.texi: (i) Add 2006 to the copyright.
	(ii) Correct two typos.

	* cc-defs.el: Update the version string to "5.31.4".

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/index.php, admin/release.php: Update for release 5.31.3.

	* ChangeLog: Fixed last minute bug in cc-mode.el.

	* cc-mode.el (c-postprocess-file-styles):
	bind inhibit-read-only to t, around the call
	to c-remove-any-local-eval-or-mode-variables, so that it works on a RO
	file.

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for release 5.31.3.

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.3

2006-02-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-postprocess-file-styles): bind inhibit-read-only
	to t, around the call to
	c-remove-any-local-eval-or-mode-variables, so that it works on a
	RO file.

2006-02-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-emacs-features): Don't assume point-min==1.

	* cc-awk.el: Correct a typo.

2006-02-15  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* admin/changes-531.php, cc-mode.texi, NEWS, cc-cmds.el,
	cc-mode.el: Rename c-hungry-backspace to
	c-hungry-delete-backwards, at the request of RMS.  Leave the old
	name as an alias.

2006-02-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Correct the definition of c-beginning-of-defun, to include the
	function header within the defun.
	(ii) Two minor amendments from Savannah.

	* cc-fix.el: In the test for a broken (XEmacs)
	font-lock-compile-keywords, exclude GNU Emacs, whose CVS version
	would now signal an error.

2006-02-10  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fix.el, cc-guess.el, cc-lobotomy.el, cc-styles.el,
	cc-subword.el, cc-vars.el, cc-langs.el, cc-menus.el, cc-mode.el,
	cc-fonts.el, cc-bytecomp.el, cc-cmds.el, cc-compat.el, cc-defs.el,
	cc-engine.el, cc-awk.el, cc-align.el:
	(i) Add 2006 to the copyright statement.
	(ii) Correct a typo in cc-mode.el.

	* cc-mode.texi: (i) Add 2006 to the copyright.
	(ii) Correct two typos.

2006-02-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el: Update the version number to 5.31.3.

2006-02-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fix clean-up brace-else-brace
	(error due to mbeg, mend being undefined).

2006-02-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: File Local variables: Solve the problem where both
	`mode' and c-file-offsets are specified: `mode' will overwrite
	c-f-o's settings:
	(c-remove-any-local-eval-or-mode-variables): new function.
	(c-postprocess-file-styles): call the above new function, within
	c-tentative-buffer-change, to splat `mode' and `eval' before the
	second hack-local-variables.

2006-01-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el:
	[Alternative patch to GNU Emacs: cc-engine.el V 1.45]
	(c-after-change): Protect the match data with save-match-data.  It
	was getting corrupted by c-after-change-check-<>-operators.

	* cc-defs.el: [3 Patches from GNU Emacs: savannah V 1.3[678]:
	(top level): Check for a buggy font-lock-compile-keywords ONLY in
	XEmacs.  GNU Emacs 22 now has a check which would throw an error
	here.
	(c-emacs-features): Use (point-min) and (point) rather than
	hard-coded 1, in case the buffer is narrowed.

	* cc-awk.el (c-awk-after-change): Protect the match data with
	save-match-data.  It was being corrupted when Font Lock was not
	enabled.

2006-01-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* ChangeLog: Update for release 5.31.2.

2006-01-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.2

2006-01-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi (Comment Commands): State that C-u M-; kills any
	existing comment.
	(Electric Keys): Add a justification for electric indentation.
	(Hungry WS Deletion): Clear up the names and complications of the
	BACKSPACE and DELETE keys.

2006-01-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-basic-common-init): Concatenate the minor mode
	indicators directly onto mode-name, removing c-submode-indicators.
	Sometimes, c-s-i got separated from the mode name on the mode
	line.

	* cc-langs.el (c-mode-menu): Add menu items for Electric Mode and
	Subword Mode.

	* cc-engine.el: Concatenate the minor mode indicators directly
	onto mode-name, removing c-submode-indicators.  Sometimes, c-s-i
	got separated from the mode name on the mode line.
	(c-beginning-of-statment-1): Distinguish real labels ("case 1:" or
	"foo:") from non-labels ("public:").
	(c-forward-objc-directive): Replace c-forward-token-2 with crude
	coding; c-f-t-2 doesn't move over a token at EOB.

	* cc-defs.el (c-version): Update version number to 5.31.2

	* cc-cmds.el (c-update-modeline): Concatenate the minor mode
	indicators directly onto mode-name, removing c-submode-indicators.
	Sometimes, c-s-i got separated from the mode name on the mode
	line.
	(c-electric-brace, c-electric-semi&comma, c-electric-colon):
	Correct doc-strings: "/ln" -> "/la".

2006-01-17  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-make-init-lang-vars-fun): Improved the error
	message when there's an evaluation error to show whether it's
	loaded from source or not.
	(c-filter-ops): Made it available at runtime too to work when
	`c-make-init-lang-vars-fun' needs to evaluate from source.

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.1

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* NEWS: Correct the spelling of Masatake YAMATO's name (with
	apologies to him).

2005-12-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-version): <- 5.31.1

	* cc-defs.el: Restore the (correct) (c-external-require 'cl).

2005-11-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* Release 5.31.

2005-11-30  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Spelling and minor typographical changes.

2005-11-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el, cc-awk.el:  Spelling corrections.

	* cc-cmds.el (c-electric-paren): Only call the
	`blink-paren-function' for a CLOSE parenthesis.

	* cc-defs.el: Change "(cc-external-require 'cl)" to
	"(eval-when-compile (require 'cl))".  (The change came from
	savannah - I don't understand it.)

	* cc-engine.el: Add an autoload to c-guess-basic-syntax (From
	savannah.)
	
	* cc-langs.el: Add "(cc-external-require 'cl)".

	* cc-mode.el (c-font-lock-init): "Add (font-lock-lines-before
	. 1)".
	
	* cc-subword.el: Add a dummy `c-subword-mode' for Emacsen which
	lack `define-minor-mode'.  (Currently Emacs <21.  We might do this
	function properly in the future).

2005-11-28  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-defs.el, cc-styles.el, cc-vars.el: New macros
	c-sentence-end and c-default-value-sentence end, to cope with
	Emacs 22's new function `sentence-end'.

2005-11-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-show-syntactic-information): Solved the compat
	issue using `c-put-overlay' and `c-delete-overlay'.

	* cc-defs.el (c-put-overlay, c-delete-overlay): New compat macros
	to handle overlays/extents.

2005-11-25  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-fix.el: Add definitions of the macros push and pop (for GNU
	Emacs 20.4)

	* cc-defs.el:
	(i) Load cc-fix.elc for `push' and `pop' (for GNU Emacs 20.4)

	* cc-cmds.el (c-show-syntactic-information): change the
	highlighting mechanism so it will work in XEmacs too.

	Remove several unused dynamic bindings.

	* cc-defs.el: Insert c-int-to-char.

	* cc-langs.el (c-nonsymbol-token-char-list): Insert a call to the
	new macro c-int-to-char.  This solves XEmacs's regarding
	characters as different from integers.

2005-11-25  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-make-syntactic-matcher): New internal helper.

	(c-cpp-matchers, c-basic-matchers-before): Use the `eval'
	construct to make the indirect face lookup work in XEmacs.

	(c-cpp-matchers): Append the negation char face to the existing
	fontification, so that the cpp face doesn't disappear.  Use
	`c-make-syntactic-matcher' to avoid negation chars in comments and
	strings.

2005-11-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-negation-char-face-name): New variable to map to
	`font-lock-negation-char-face' in emacsen where it exists.

2005-11-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Bind c-subword-mode to C-c C-w.

	* cc-mode.texi:
	(i) Document the binding C-c C-w, in "Minor Modes" and in "Subword
	Movement".
	(ii) Mark c-\(forward\|backward\)-into-nomenclature as superseded
	by c-subword-mode.
	(iii) "Config Basics": change the troublesome "@itemize @w" to
	"@itemize @asis".
	(iv) Eliminate the "@defvr {LIST}" construct in "Adding Styles".
	Bring descriptions of subsidiary matters into the definition of
	the style description by shifting an "@end".

2005-11-22  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-subword.el, cc-cmds.el, cc-mode.el: Rename
	"c-subword-move-mode" as "c-subword-mode".

	* cc-mode.texi, cc-subword.el: cc-subword.el: In
	c-forward-subword-internal, check that the regexp doesn't match a
	null string.  This can happen, e.g., in Info Mode, where ' has the
	syntax of a word constituent.

	cc-mode.texi:
	(i) "Subword Movement": Say that subword-move-mode is available in
	non-CC Modes.
	(ii) "Config Basics": Add a recommendation to beginners to use the
	top-level setq mechanism.
	(iii) "Config Basics": Deobfuscate the description of top-level
	setq's.

	* cc-mode.texi:
	(i) Add a description of the various build commands
	(e.g. makeinfo), as supplied by Robert Chassell.
	(ii) Move description of `comment-region' from "Other Commands" to
	"Comment Commands".
	(iii) Remove C-c C-y (which used to be bound to
	c-toggle-hungry-state).
	(iv) Added a @footnote about the change of the binding C-c C-d.
	(v) Reinstated the description of `c-toggle-auto-hungry-state'.

	* cc-mode.el: Remove the binding C-c C-y for c-toggle-hungry-state

	* cc-cmds.el: Reinsert c-toggle-auto-hungry-state (but with no
	binding).

2005-11-21  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added tty suitable bindings for C-c <delete> and C-c
	C-<delete>.  (To the c-hungry- delete functions).

2005-11-21  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Added autoload directive for `c-subword-move-mode'
	for use in older emacsen.

2005-11-20  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el:
	(i) Insert a binding for C-c C-backspace into
	c-bind-special-erase-keys which works in TTYs.
	(ii) Make sure that when file styles are used, any explicitly
	given style variables take priority over those in the style.  Do
	this by calling `hack-local-variables' a second time.

	* cc-vars.el: Add language specific customization widgets for AWK
	to c-doc-comment-style, c-require-final-newline and
	c-default-style.  Add a defcustom for awk-mode-hook.  Give
	c-syntactic-element and c-syntactic-context doc-strings by
	directly setting their `variable-documentation' propery.  This
	allows Emacs 22.1 to read these with C-h v.

	* cc-awk.el: Apply a tidy-up patch (from Stefan Monnier).

2005-11-20  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Mention gtkdoc.

	* cc-mode.texi: The concept index also contains the keys. Make
	that more obvious so that the keys are found more easily.

	* cc-mode.texi: Updated the Hungry WS Deletion section on the
	details about the C-c C-<backspace> bindings etc.

	* cc-mode.texi: Added a section about the subword minor mode.

	* cc-fonts.el, cc-vars.el (gtkdoc-font-lock-doc-comments,
	gtkdoc-font-lock-doc-protection, gtkdoc-font-lock-keywords):
	GtkDoc patterns contributed by Masatake YAMATO.

	(c-doc-comment-style): Made GtkDoc default in C mode.

2005-11-19  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el: Fixed key bindings for C-c C-<backspace> and C-c
	C-<delete>.

	(c-bind-special-erase-keys): New function for use on
	`normal-erase-is-backspace-hook' to bind C-c C-<delete> correctly.

	* cc-cmds.el (c-hungry-delete): New function to fix <delete> key
	behavior in XEmacs according to `delete-forward-p'.
	C.f. `c-electric-delete'.

2005-11-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: DVI stuff: Remove the quotes from "GNU Emacs
	Manual" and friends.  Complete several cross references with their
	fifth parameter (the name of the printed manual).

	"Indentation Commands": Tidy up `c-indent-command', putting the
	variables `c-tab-always-indent' and `c-insert-tab-function' inside
	its description.  Inserted some "printed manual names" into cross
	references where they were missing.  Move description of
	`indent-for-comment' into ...

	"Comment Command": A new @section under "Commands"; it contains
	the description of `indent-for-comment'; this was taken out of
	"Indentation Commands".  Add GNU Emacs's new name `comment-dwim'
	for this function.

	"Sample .emacs File": Change "@example" to "@verbatim" so that the
	text isn't indented.  Reorder the Lisp forms.

2005-11-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Configuration Basics": Add a note that ".emacs"
	means "whatever initialization file you fancy".  Also, another
	note that the mode hooks are good places to put personal
	preferences.

	"Performance Issues": Remove the recommendation to put defun
	braces at column 0, replacing it with a historical remark.

	"Limitations and Known Bugs": State that C++ templates aren't yet
	handled fully.

2005-11-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Renamed @chapter "Getting Connected" to "Getting
	Started" and @chapter "Config Strategies" to "Config Basics".

	"Getting Started": Added "quick fix" configurations for four of
	the most common requests (c-basic-offset, c-set-style,
	c-electric-mode, <RET> should indent NL).

	"FAQ": Permuted the questions a little.  Added "How can I change
	the indent level from 4 spaces to 2 spaces?".  Added several cross
	references.

2005-11-05  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Move c-toggle-hungry-state from "C-c C-d" to "C-c C-y".  Give
	  c-hungry-backspace and c-hungry-delete-forward permanent key bindings.

	* cc-mode.texi: Document the new state of affairs: Nodes changed: "Minor
	  Modes", "Hungry WS Deletion", "Sample .emacs File"

	* cc-mode.texi:
	"Style Variables": New @section explaining what style variables are and
	  how to set them.
	"Permanent Customization": Removed this @section, since its contents have
	  been moved elsewhere.
	"c-offsets-alist": New @section

	Removed much commented out material, including @examples in the Line-Up
	  sections.

	"Config Strategies": (i) Added a summary of style variables; (ii)
	  Corrected the priority of settings made by "File Local Variables";
	  (iii) Clarified and corrected how top-level `setq's interact with
	  styles; (iv) Added a terse but accurate description of the "user"
	  style.
	"Style Variables": Took over most of the stuff from "Styles", its
	  parent.  Added a @pxref to each item in the list of style variables.
	"Built-in Styles": Corrected the description of the "user" style.  Other
	  styles DO NOT inherit from it - they inherit from the factory defaults
	  in c-fallback-style.
	"Adding Styles": Clarification of inheritance from c-fallback-style.

	"Hanging Braces": Replace a tedious flowchart of what CC Mode does, with
	  a description of how to go about configuring the thing.
	"Custom Braces": Move description of c-syntactic-context to near the
	  top of the node, and note the other three circumstances it gets bound
	  (together with @xrefs).
	"Hanging Semicolons and Commas": Note that c-syntactic-context is bound.

	"Indentation Engine Basics": Clarify first stage of indentation process.
	"Syntactic Symbols" (and sub-nodes): Note the syntactic symbols which
	  don't have and anchor point, or have additional info in a syntactic
	  element.

	"Customizing Indentation": Stuff about c-offsets-alist has been moved to
	  its own new @section.
	"Line-Up Functions": Add a mention of the calling convention together
	  with a pointer to "Custom Line-Up".
	"Other Indentation": Clarify the whole @section.  State that File local
	  variables take precedence over all else, even settings in hooks.

2005-11-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): Remove the "(if t ..." construct
	which was experimentally inserted into V 5.314 (2005-08-18) to
	minimise the patch size by not changing the indentation level.

2005-11-03  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-semi&comma): Bind c-syntactic-context for
	calls to "criteria functions", for consistency with other calls to
	user functions.

2005-10-31  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-indent-command): expunge use of
	`current-prefix-arg', since this might be the prefix arg to a
	command which calls c-indent-command as a function.  Change the
	interactive spec from "p" to "P".

2005-10-04  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Minor Modes": Document the command c-toggle-syntactic-indentation.
	"Analysis": Formalise the description of
	  c-show-syntactic-information to a quasi-@defun form.  Describe the new
	  feature of highlighting anchor positions.
	Make sure there's a blank line at the top of each node.

	* cc-mode.texi: "Indentation Engine Basics":
	(i) Rearrange the paragraphs more logically;
	(ii) make @dfn's out of "syntactic symbol", "anchor position" and
	  "offset(s)".
	(iii) Make an @enumeration out of the two-step indentation process.
	(iv) Add a paragraph motivating c-syntactic-indentation, complete with a
	  reference to "Config Strategies".

2005-10-02  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Custom Line-Up":
	(i) Increase the concision of the page.
	(ii) Comment out the example.  (Maybe this should go into its own
	  @subsection.)
	(iii) Specify precisely the conventions for a line-up function, in
	  particular, that point may not be moved.
	(iv) Add in the suggestion that c-special-indent-hook may sometimes be a
	  better idea than line-up functions.
	There are minor consequential changes on other pages.

2005-09-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Partition the over-large @section "Line-Up Functions".
	(ii) Expand the description of c-special-indent-hook.
	(iii) Add cross references between "Other Indentation" and "Custom
	  Line-up", emphasizing that c-special-indent-hook functions and line-up
	  functions are alternatives.

2005-09-17  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el: Amend the doc-string of c-set-style, in reponse to
	a report from Joseph Kiniry <kiniry@acm.org> that it was difficult
	to understand.

2005-09-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-on-identifier): Fixed bug when at the first char
	of an identifier.

	* cc-engine.el (c-on-identifier): Handle the "operator +" syntax
	in C++.

2005-09-09  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi ("Syntactic Analysis"): Minor amendments.
	("Syntactic Symbols"): Partition this monster into a section with
	  thirteen subsections, each of which (more or less) illustrates a coherent
	  grouping of symbols.
	  Replace the spurious references to substatement-block-intro with
	  statement-block-intro.
	  Add @ssindex entries for those symbols missing them.

2005-09-08  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Some general tidying up and clarification.  Also:
	(Hooks):  mention c-special-indent-hook
	(FAQ): Commented out the question about M-[ae] going into blocks.

2005-08-29  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	55 Changes, great and small.  Most of them are minor linguistic
	improvements, clarifications, adding xrefs, bug fixes, or the like, but
	there are also several more notable changes:
	(i) "Config Strategies": State which setting takes precedence when
	  conflicting settings are made (e.g. both in a style and in a hook).
	(ii) "Config Strategies": Add a bit about "File Styles".
	(iii) "File Styles": Fleshed out this chapter quite a bit.
	(iv) "Mode Initialization": Removed this embryonic node (which was far
	  from complete or useful) and all references to it.

2005-08-18  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-mask-paragraph): correct, so that auto-fill
	doesn't split a c-comment's last word from a hanging "*/" when a
	space is typed between them after fill-column.

	cc-defs.el: New macro c-delete-and-extract-region.

2005-06-24  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-set-style, c-setup-paragraph-variables): Abort
	the command if we're not in a CC Mode buffer.

2005-06-13  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-C-comments): Correct indentation with
	blank comment-prefix, and a blank line as the comment's second
	line.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-cpp-matchers, c-basic-matchers-before):
	Incorporated the patterns
	added in the Emacs development branch for the new Emacs 22 face
	`font-lock-negation-char-face'.

	# Also folded some long lines.

	* cc-fonts.el (c-invalid-face-name):
	Use "red1" instead of "red" since it stands out
	better in xterms and DOS terminals.

	# Not applicable in the development version since this face is simply
	# an inverted version of font-lock-warning-face.

	* cc-engine.el (c-literal-faces):
	Added `font-lock-comment-delimiter-face' which is
	new in Emacs 22.

	# NB: The new way to font lock comments in the development version of
	# Emacs causes massive breakage in the faces test suite.  000tests.el
	# needs to be amended.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi, cc-subword.el:
	Change the FSF's address in the copyright statement.  Incidentally,
	change "along with GNU Emacs" to "along with this program" where it occurs.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Add documention for the new electric minor mode and finish that for clean-up
	comment-close-slash.  Tidy up the structure a bit, make some minor linguistic
	improvements.  In detail:

	Change "Clean-ups" from being a section of "Custom auto-newlines) to being its
	  own section, since it documents some stuff which is independent of
	  auto-nelines.
	Change "Auto-newlines" and "Hungry WS Deletion" from being subsections of
	  "Minor Modes" to their own sections, since they're to important to hide.
	  Move "Electric Keys" alongside them, since it now bears the same
	  relationship to "Minor Modes" as "Auto-newlines" and "Hungry WS .." do.
	"Indentation Commands":  Add a convenience description of standard (X)Emacs
	  C-j.
	"Minor Modes":
	  (i) Document the new "electric minor mode" with toggle C-c C-l, and the
	    coupling between it and c-toggle-auto-newline.
	  (ii) Remove the description of the defunct `c-toggle-auto-hungry-state'.
	  (iii) Update the description of the modeline flags.
	  (iv) Recast the node considerably in the process.
	"Electric Keys and Keywords":
	  (i) Add a note that electric minor mode needs to be enabled for (most of)
	    the stuff here to work.
	  (ii) Mention the new clean-up comment-close-slash.
	  (iii) Note the electric actions which don't need electric minor mode to be
	    enabled.
	"Sample .emacs File":  Replace c-toggle-auto-hungry-state with
	  c-toggle-\(auto-newline\|hungry-state\).
	"FAQ": Add an entry "How do I stop my code jumping all over the place when I
	  type?".

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: Correct previous patch to c-toggle-auto-newline.

	* NEWS: Add an entry for the new clean-up `comment-close-slash'.

	* cc-mode.texi: Document the new clean-up `comment-close-slash'.

	* cc-cmds.el:
	Make C-c C-a (`c-toggle-auto-newline') forcibly enable c-electric-flag.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el, cc-cmds.el:
	New clean-up `comment-close-slash' on c-electric-slash: if enabled, typing `/'
	  just after the comment-prefix of a C-style comment will close that comment.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Sync with Lute Kamstra's patch from emacs-devel to prevent a superfluous
	  cc-mode.ss index file being built with texi2dvi.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-basic-matchers-before, c-complex-decl-matchers):
	Fixed the
	"not-arrow-prefix" regexp used in Pike.

	* cc-langs.el (c-other-op-syntax-tokens): Only C++ has digraphs.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Resolve some CVS conflict markers.

	* cc-mode.texi:
	Custom Filling and Breaking:  State that c-comment-prefix regexp can be
	  an association list.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el, cc-engine.el (c-cpp-message-directives, c-cpp-include-directives, c-opt-cpp-macro-define, c-opt-cpp-macro-define-start, c-cpp-expr-directives):
	Introduced new
	language constants to control cpp syntax in a cleaner way.

	(c-cpp-expr-functions): Renamed from c-cpp-defined-fns.

	(c-cpp-matchers, c-forward-to-cpp-define-body): Use them.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-fonts.el (c-string-escaped-newlines, c-multiline-string-start-char):
	New language
	constants and variables to specify how newlines in string literals work.

	(c-font-lock-invalid-string): Use them.

	* cc-mode.texi:
	Removed hint that the one-liner-defun cleanup only would be
	useful/relevant in AWK mode.

	* cc-cmds.el (c-try-one-liner):
	Robustness fix if an unbalanced close brace is
	entered.  Optimization by avoiding going back over arbitrarily large
	blocks.  Removed hints that this function only would be
	relevant/useful in AWK.

	# I also got the chance to put in a clarifying comment in Alans code!
	# Whooho! :)

	(c-electric-brace): Indent syntactically after the cleanups since
	lineup functions might do it differently then.

	* cc-engine.el, cc-langs.el (c-opt-op-identifier-prefix):
	New language constant and variable.

	(c-just-after-func-arglist-p, c-after-special-operator-id,
	c-search-decl-header-end, c-inside-bracelist-p): Use it.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax):
	Handle operator declarations somewhat better
	in C++.

	# Full fix is in 5.31 only.

	* cc-align.el, cc-engine.el (c-after-special-operator-id):
	New helper to handle C++ operator identifiers.

	(c-lineup-topmost-intro-cont, c-just-after-func-arglist-p,
	c-guess-basic-syntax): Handle C++ operator identifiers in declarations.

	* cc-langs.el (c-assignment-operators):
	Added the trigraph version of ^= too.

	* cc-langs.el (c-assignment-operators):
	Added the trigraph version of |= in C++.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Advanced Customizations":  Finally remove the vestiges of this chapter.
	Resolve three other minor FIXMEs.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarators):
	Handle `c-decl-hangon-kwds' after the
	identifier name.

	* cc-engine.el (c-guess-basic-syntax):
	When deciding whether an arglist is
	"nonempty", ignore a comment after the open paren if it isn't followed
	by a non-comment token on the same line.

	* cc-engine.el (c-guess-basic-syntax):
	Case 4: Enable heuristics below the point to
	cope with classes inside special brace lists in Pike.

	* cc-engine.el:
	Reverted the attempt to clean up the handling of arglists since I've
	given up trying to get it to work in a somewhat compatible way.  It's
	simply too broken by design and has to be fixed in a new major
	version.

	The revert affects these revisions of cc-engine.el: 5.517 made
	2004-06-29 and 5.518 made 2004-09-26.  Exceptions are the utility
	functions `c-at-expression-start-p' and `c-at-statement-start-p',
	and the new flag to `c-looking-at-inexpr-block'.

	# In connection with this, the following tests are reverted:
	#
	# Tests changed 2004-06-29 in connection with 5.517:
	# tests/arglist-18.c: 1.3
	# tests/arglist-18.res: 1.5
	# tests/arglist-21.pike: 1.2
	# tests/arglist-21.res: 1.2
	# tests/arglist-3.cc: 1.4
	# tests/arglist-3.res: 1.10
	#
	# Tests changed 2004-09-26 in connection with 5.518:
	# tests/arglist-11.res: 1.6
	# tests/arglist-17.res: 1.2
	# tests/arglist-3.res: 1.11
	# tests/class-12.java: 1.7
	# tests/class-12.res: 1.12
	# tests/if-4.res: 1.4
	# tests/inexprstat-1.pike: 1.5
	# tests/inexprstat-1.res: 1.9
	# tests/inexprstat-2.cc: 1.9
	# tests/inexprstat-2.res: 1.11
	# tests/top-4.c: 1.2
	# tests/top-4.res: 1.9

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Correct a typo in the sourceforge CVS URL.

	* cc-mode.texi:
	Add a statement that the manual is GPL'd.  Add a pointer to the manual's source
	at sourceforge.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-cmds.el:
	cc-cmds.el:  Amend c-point-syntax to handle macros.
	cc-langs.el:  Comment c-opt-cpp-prefix with a "TODO: handle escaped EOLs".

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-guess.el (cc-guess-install):
	New function to install an already guessed style
	in another buffer.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-guess.el:
	Improvement contributed by Masatake YAMATO: Frequency is now taken
	into account to make a better guess.

	(cc-guess-region): Inverted the RESET argument to make it more
	convenient.  The guessed style is also merged into `c-offsets-alist'
	right away.

	(cc-guess, cc-guess-view-style): New functions.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-tentative-buffer-changes):
	No longer sets `inhibit-read-only' -
	`c-save-buffer-state' should be used anyway if the change always is
	undone.

	#(c-save-buffer-state, c-tentative-buffer-changes): Extended the
	#docstrings a bit more.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-vars.el, cc-mode.el, cc-langs.el, cc-defs.el, cc-engine.el:
	Implement togglable electricity:

	cc-defs.el: Enhance c-save-buffer-state's doc-string, saying when it
	  should be used.

	cc-engine.el: Add the new buffer-local variable, c-electric-flag.

	cc-langs.el: Change the name of c-toggle-auto-state to
	  c-toggle-auto-newline.

	cc-mode.el: Rename c-toggle-auto-state to c-toggle-auto-newline.  Remove
	  the binding for c-toggle-auto-hungry-state.  Add the binding C-c C-l
	  for the new c-toggle-electric-state.

	cc-vars.el: Make c-syntactic-indentation buffer local.

	cc-cmds.el:
	  Add `c-bytecomp-defun's for c-\(forward\|backward\)-subword.
	  c-update-modeline:  Add the new modeline flag `l' for
	    `c-electric-flag'.  Make the auto-newline flag `a' dependent on `l'.
	  c-toggle-auto-state:  Rename it to `c-toggle-auto-newline'.  Make the old
	    name an alias of the new name.
	  Remove `c-toggle-auto-hungry-state'.
	  Add new function `c-toggle-electric-state'.
	  c-electric-\(pound\|brace\|slash\|star\|semi&comma\|colon\|lt-gt\|
	    paren\|continued-statement\): Adapt these functions to do electric
	    things only when c-electric-flag is non-nil.
	  c-point-syntax, c-brace-newlines, c-try-oneliner: Extract these new
	    functions from c-electric-brace.
	  c-point-syntax: Add a check for "virtual semicolons" in AWK mode, so that
	    the tentative extra newline doesn't change the syntax of the following
	    brace.
	  c-electric-brace: restructure by extracting the above functions.  Tidy up
	    the coding somewhat.
	  c-electric-semi&comma, c-electric-colon, c-electric-paren: restructure a bit.

	* cc-mode.texi:
	"Electric Keys": Amend description of `<' and `>': they are also electric when
	  they are template brackets.
	"Other Commands": Add an entry for the standard Emacs command `comment-region'
	  which has CC Mode binding C-c C-c.
	"Custom Filling and Breaking": Purge the description of
	  `c-comment-prefix-regexp' of confusing gobbledygook.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Filling and Breaking":  Add a cross reference to "Custom Filling and
	Breaking".
	Several minor amendments.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Merge the changes made on branch texi-0-1 back to HEAD.
	CV1: Committing in .

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: "Overview":  Get rid of reference to "AWK" section;
	"Sample .emacs FILE":  Put key bindings into c-initialization-hook;
	  Move the c-add-style call from out of the c-mode-hook.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	In the GNU/XEmacs conditional things, replace "X" by "XEMACS" for clarity.
	Rename the chapter "Indentation Engine" to "Indentation Engine Basics".
	"Indentation Commands": Add stuff about macros (taken from the old "Macro
	  Handling" chapter).
	"Other Commands":  Move the description of "c-backslash-region" into here.
	Rename "Macro Handling" to "Custom Macros", having moved the stuff other than
	  customization to other chapters.

	* cc-vars.el:
	Remove the erroneous (doubly inserted) patch from yesterday.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-show-syntactic-information):
	Show the anchor position(s) using
	faces.  Thanks to Masatake YAMATO for the idea.

	* cc-mode.el, cc-cmds.el, cc-defs.el, cc-engine.el (c-submode-indicators):
	Changed name from `c-auto-hungry-string' since it's
	now used to track another submode.

	(c-update-modeline): Converted to function and extended to check
	`c-subword-move-mode'.

	(c-forward-into-nomenclature, c-backward-into-nomenclature): Converted to
	compat aliases for `c-forward-subword' and `c-backward-subword'.

	* MANIFEST, Makefile: Added cc-subword.el.

	* cc-subword.el:
	New functions and minor mode to handle SillyCapsedStyleIndentifiers,
	contributed by Masatake YAMATO:

	(c-forward-subword, c-backward-subword, c-mark-subword, c-kill-subword,
	c-backward-kill-subword, c-transpose-subwords, c-capitalize-subword,
	c-downcase-subword, c-upcase-subword): Functions corresponding to the
	standard word handling functions.

	(c-subword-move-mode): Minor mode that replaces all the standard word
	handling functions with their subword equivalences.
	#Note that this requires `define-minor-mode', which is known to exist in
	#Emacs 21 and later.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-vars.el:
	c-cleanup-list:  Insert a customization entry for one-liner-defun.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-defs.el:
	Give c-tentative-buffer-changes its own name in its def-edebug-spec.

	* cc-cmds.el:
	c-electric-brace: Make the one-liner-defun clean-up work with
	  empty-defun-braces.  o-l-d now compacts space before a comment, if this will
	  make things fit on one line.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* NEWS:
	Added some tentative entries for version 5.31:  (i) Older [X]Emacs
	  versions are no longer supported; (ii) Revision of the Manual;  (iii)
	  Improvements to AWK support.

	* cc-mode.texi:
	"AWK Mode Defuns":  Removed this subsection, transferring its contents to
	  "Movement Commands"
	"Movement Commands":  Condensed the separate descriptions of
	  complementary -backward-* and -forward-* commands into joint
	  descriptions.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	"Introduction":  Integrated Alan more tightly into CC-Mode.  ;-)
	"Overview":  New chapter describing the structure of the manual.
	"Other Commands":  Added a description of c-macro-expand.
	"Built-in Styles":  Added a description of the new "awk" style.
	"Custom Braces" and "Hanging Semicolons and Commas":  Specify the meaning of
	  point in action functions, and that is must be preserved.
	"Clean-ups":  Document the new clean-up one-liner-defun and associated
	  variable c-max-one-liner-length.
	"Customizing Indentation" is now its own chapter rather than being a section
	  of "Indentation Engine".
	"AWK Mode:  Removed the entire chapter, moving the two remaining useful
	  sections to "Font Locking" and "Movement Commands".
	Added/Moved lots of index entries.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-styles.el, cc-vars.el, cc-align.el:
	Introduce an "awk" style, mainly for auto-newline and clean-ups.
	cc-align.el: new function c-snug-1line-defun-close
	cc-cmds.el: In c-electric-brace, add code for new clean-up one-liner-defun.
	cc-styles.el: Add the new "awk" style.
	cc-vars.el: Add description of one-liner-defun to c-cleanup-list's doc-string.
	  New user options, c-max-one-liner-length.
	  In c-default-style, set the default style for AWK to "awk".

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* MANIFEST: Don't think there's any need for credits in this file.

	* README, ANNOUNCEMENT: Alan does more than AWK nowadays. :)

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-label):
	Fixed fontification of macros inside labels.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	(i) Some general tidying up, remove @ignore sections, etc.
	(ii) Firm up the mechanism for generating @xrefs to the Emacs/Xemacs
	  manual and the Elisp/Lispref manual.  There are now four macros,
	  @emacsman{}, @lispref{}, @emacsmantitle{}, @lispreftitle{} which
	  generate the filenames and titles (for the printed versions) of the
	  manuals pertinent to Emacs or XEmacs, depending on whether the makeinfo
	  variable `X' is defined or not.  The titles were taken from the
	  @settitle lines in the source files of the four manuals.  In the
	  process, the title "The Emacs Editor" has been amended to "GNU Emacs
	  Manual".

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Much general tidying up of the wording.
	"Auto-newlines"
	  (i) Add a note that c-electric-* only do their stuff when last on
	    line.
	  (ii) State that a `before' auto-newline is never added if the `{'
	    etc. is "already on a newline".
	  (iii) Replace the statement of where auto-newlines go by default (it
	    was wrong and oversimplified) by a statement that the style system
	    does the configuration most of the time.
	"Custom Auto-newlines"
	  (i) Make the page what it says it is, removing the stuff which is now
	    in "Commands".
	  (ii) Add a @dfn{} for "hang", and "hanging on the left/right".
	  (iii)
	"Hanging Braces"
	  (i) Insert an @enumerated section describing the algorithm.
	  (ii) Insert a more robust description of c-hanging-braces-alist.
	  (iii)
	"Hanging Colons"
	  (i) Update this page to mirror "Hanging Braces".
	  (ii) State that the default action (if no alist entry) is to add no
	    newlines.
	"Custom Semis and Commas"
	  (i) Add clarification that criteria functions don't themselves add
	    newlines.
	  (ii) State that NLs never get added _before_ a `;' or `,'.
	  (iii)
	"Clean-ups"
	  (i) Give an actual definition of "Clean-up" for the @dfn{}. ;-)

	Moved the @section "Custom Brace and Colon Hanging" away from "Advanced
	  Customizations" to underneath "Hanging Braces", removing the spurious
	  "and Colons" from its name.
	Moved the contents of the @section "Customizing Semicolons and Commas"
	  away from "Advanced Customizations" and inserted them into "Hanging
	  Semicolons and Commas" (which previously had only a pointer into the
	  CSaC node).
	"Advanced Customization" is now almost content free.

	Add Experimental macros for "Emacs"/"XEmacs" and "Elisp"/"Lispref", in
	  the hope they might enable a better XEmacs version of the manual.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-bos):
	Obsoleted in favor of `c-at-statement-start-p' and
	`c-at-expression-start-p'.
	#I actually forgot about this when I introduced
	#`c-at-statement-start-p', but I think the new ones got better names
	#so I deprecate this one anyway.

	* cc-defs.el (c-tnt-chng-record-state):
	Don't signal an error if the mark isn't set.

	* cc-engine.el (c-guess-continued-construct, c-guess-basic-syntax): Use
	`c-forward-decl-or-cast-1' to more accurately detect functions inside
	functions.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Reorder the chapters a bit on the principle "Most basic earliest":
	  Move "Font locking" with contents to just after "Commands".
	  Move "Indentation Engine" with contents to just after "Custom Filling and
	    Breaking".
	  Move "Custom Filling and Line Breaking" to before "Custom Auto-Newlines".

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Add a "Mode Initialization" section (as yet, content free) to
	    "Configuration Strategies".
	  Move "Minor Modes" into the "Commands" chapter.  Remove the
	    configuration instructions from its submode "Auto-newlines".  Outline
	    the default configuration for auto-newlines here.
	  Rename the old "Auto-newline insertion" to "Customizing Auto-newline
	    Mode" and make it a @chapter in its own right, containing four
	    sections.  The content of this @chapter is yet to be adapted.
	  Amend the descriptions in "Minor Modes" of the key sequences, using
	    @table rather than an unbroken textual paragraph.
	  Amend "Electric Keys", so that there is explicit reference to
	    "Clean-ups" in the right places.  All electric actions are now
	    collected together in this section.
	  Condense the description of '*' and '/' in Electric keys.
	  In "Clean-ups" insert "@tie{}" where a critical space was getting lost
	    in line wrap.
	  Tidy up a lot of wording.
	  Introduce an experimental facility which will build either a GNU Emacs
	    or an XEmacs specific info file.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-at-expression-start-p):
	New function like `c-at-statement-start-p'
	that additionally recognizes commas and expression parentheses as
	delimiters.

	(c-at-statement-start-p): The optional COMMA-DELIM argument is gone.
	Use `c-at-expression-start-p' instead.

	(c-guess-basic-syntax): More consistent anchoring for `arglist-close'.
	The main effect is that the anchor position is at the start of the
	statement instead of the opening paren even when the opening paren is
	at boi.  Thus odd indentation is avoided in that case if
	`arglist-close' is set to `+'.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el:
	  Add character classes (e.g. "[:alpha:]") into AWK Mode's regexps.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Move the page "Hungry WS Deletion" into the "Commands" chapter, and
	    revise this node for (hopefull) increased clarity.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Reduce the length of many node names, (following suggestion on
	    emacs-devel).
	  Tidy up some of the wording.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:   Added ACM to the list of authors.
	  Renamed "Other Electric Commands" to "Electric Keys and Keywords"
	  In "Electric Keys and Keywords", added descriptions of {, }, :, ;, ,,,
	    and tidied up the wording a bit.
	  Tidied up the wording and presentation of "Configuration Strategies".
	  In "Customizing Filling and Line Breaking", expanded the description of
	    c-comment-prefix-regexp.

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	  Moved the "Commands" chapter to near the start of the file.
	  Moved "Other Electric Commands" into the "Commands" chapter.
	  Split "Text Filling and Line Breaking" into the "Filling and Line
	Breaking Commands" (a section under "Commands"), and "Customizing Filling
	and Line Breaking".

2005-06-01  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.texi:   Update the master menu for the file.

	* cc-mode.texi:
	  This change is the first stage in the restructuring of cc-mode.texi.
	  Added new chapter, "Configuration Strategies", and converted "Hooks" and
	"Styles" (together with the latter's sub-nodes) into sections of this new
	chapter.
	  Converted "Syntactic Symbols" and "Customizing Indentation" (together with
	the latter's sub-nodes "Interactive C.." and "Permanent C..") into sections of
	"Indentation Engine".  "Customizing Indentation" has acquired "Line-Up
	Functions", "Custom Line-up Functions" and "Other Special Indentations" as
	sub-nodes, but has lost "Hooks" and "Styles").
	  "Advanced Customization", formerly a sub-node of "Customizing Indentation"
	is now a chapter in its own right.  It has lost "Custom Line-Up Functions" and
	"Other Indentations".

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Checklist.txt: Some updates.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-anchor-stmt, c-add-class-syntax, c-add-inclass-syntax, c-guess-continued-construct, c-guess-basic-syntax):
	Cleaned up
	anchoring of various brace block constructs inside arglists, so that
	all variants of them are treated uniformly.

	(c-anchor-stmt): Changed calling convention and renamed from
	`c-add-stmt-syntax'.

	(c-looking-at-inexpr-block): Added flag to avoid heuristics that
	doesn't work for unclosed blocks.

	(c-at-statement-start-p): New function.
	#Not used anywhere as it turned out, but it seems useful and it's
	#small.

	(c-guess-basic-syntax): Simplified the `paren-state' variable to
	always contain the whole paren state.

	* cc-align.el (c-block-in-arglist-dwim):
	Isolated the DWIM logic to line up brace
	blocks in arglists to this function.  Also extended it to cope better
	with various sorts of blocks.

	(c-lineup-arglist, c-lineup-arglist-close-under-paren,
	c-lineup-close-paren): Use `c-block-in-arglist-dwim'.  Fixed
	indentation inside Pike special brace lists.

	(c-lineup-inexpr-block): Use absolute indentation.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el:
	Fixes in handling of Objective-C directives, e.g. directives spanning lines
	should work reasonably well now.

	(c-put-c-type-property, c-clear-c-type-property): New helpers.

	(c-forward-objc-directive): New function to move over any ObjC directive.

	(c-just-after-func-arglist-p, c-guess-basic-syntax,
	c-basic-matchers-before): Use it.

	(c-font-lock-objc-iip-decl): Removed.

	* cc-engine.el (c-guess-basic-syntax):
	Some improvement in the template arglist
	recognition.
	#I.e. one use less of c++-template-syntax-table.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist):
	Fixed several inconsistencies in the Whitesmith
	style.

	* cc-mode.texi:
	Documented c-lineup-after-whitesmith-blocks.  Some other fixes.

	* cc-align.el (c-lineup-after-whitesmith-blocks):
	New lineup function to get lines
	after Whitesmith style blocks correctly indented.

	(c-lineup-whitesmith-in-block): Backed out the compensation for
	opening parens since it's done using `add' lists in the style
	definition instead.  Don't use the anchor position since it varies too
	much between the syntactic symbols. :P

	* cc-vars.el (c-valid-offset): Updated.

	* cc-mode.texi:
	Updated the doc for offset specifications on `c-offsets-alist'.

	* cc-engine.el (c-evaluate-offset):
	Extended to handle lists where the offsets are
	combined according to several different methods: `first', `min',
	`max', and `add'.  Report offset evaluation errors with
	`c-benign-error' so that some kind of reindentation still is done.

	* cc-engine.el (c-guess-basic-syntax):
	Anchor `arglist-intro' the same way as
	`arglist-cont-nonempty' and `arglist-close'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Updated the parts dealing with line-up functions.  Fixed some
	terminology to use the same words everywhere.

	* cc-langs.el (c-opt-identifier-concat-key-depth): New constant.

	#(c-identifier-ops): Talk about the "." operator in Java.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el:
	Use `cc-bytecomp-fboundp' and cc-bytecomp-boundp' in a number of places.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-langs-are-parametric):
	Made it known at compile time to avoid
	warnings.

	* cc-defs.el (c-langs-are-parametric):
	Must be known at compile time for the sake of
	`c-major-mode-is'.

	(c-mode-is-new-awk-p): Made it a macro to delay expansion of
	`c-major-mode-is' in the event that this is used inside a
	`c-lang-defconst'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1):
	Fixed a macro related issue.
	#Seems like I somehow lost track halfway through the fix in 5.476.
	#Strange that there weren't any test cases that nailed this.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Enhanced the style doc somewhat more.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations):
	Always narrow to the fontified region so
	that fontification doesn't occur outside it (could happen e.g. when
	fontifying a line with an unfinished declaration).

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Makefile:
	Recompile only as much as necessary. This way the .el files are also
	compiled one by one which makes it easier to discover the dependencies
	between them.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace):
	Cleaned up using `c-tentative-buffer-changes'.

	* cc-defs.el (c-region-is-active-p):
	Simplified and converted to macro to choose
	between Emacs and XEmacs at compile time.

	(c-set-region-active): New set counterpart to `c-region-is-active-p'.

	(c-tentative-buffer-changes): New macro to handle temporary buffer
	changes in a convenient way.

	(c-tnt-chng-record-state, c-tnt-chng-cleanup): Internal helpers for
	`c-tentative-buffer-changes'.

	* cc-cmds.el (c-electric-brace):
	Don't trip up on a line continuation which might
	precede the newly inserted '{'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block):
	Tightened up the checks for paren sexps
	between the point and the keyword, to avoid some false alarms.

	* cc-engine.el, cc-langs.el (c-looking-at-inexpr-block):
	Fixed a situation where an error could be
	thrown for unbalanced parens.  Changed to make use of
	c-keyword-member' to avoid some repeated regexp matches.

	(c-opt-lambda-key, c-opt-inexpr-block-key, c-opt-inexpr-class-key):
	These language variable are no longer necessary.

	(c-block-stmt-kwds): New language constant used by
	c-looking-at-inexpr-block'.

	(c-guess-basic-syntax): Removed an optional check that looked at the
	existence of the now removed language variables.

	* cc-engine.el (c-fdoc-shift-type-backward, c-forward-decl-or-cast-1):
	Fixed invalid
	recognition of C++ style object instantiation expressions as
	declarations in some contexts.  This bug only affected languages where
	the declarator can't be enclosed in parentheses.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el (c-style-alist):
	Fixed the GNU style to insert newlines before and
	after substatement braces.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el:
	Improved the heuristics for recognizing function declaration headers
	and the handling of C++ style member init lists.

	(c-just-after-func-arglist-p): Rewritten to use
	`c-forward-decl-or-cast-1'.  Now behaves a bit differently too.

	(c-beginning-of-member-init-list): Removed since it isn't used
	anymore.

	(c-guess-basic-syntax): Case 5B adapted for the new
	`c-just-after-func-arglist-p'.  Cases 5B.1 and 5B.3 merged.  Cases
	5D.1 and 5D.2 removed since they aren't trigged anymore (case 5B.1
	covers all cases now).

	#(c-forward-decl-or-cast-1): Doc comment fixes.

	* cc-defs.el (c-point): Added 'bosws and 'eosws.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Checklist.txt:
	Mention that there's a version number in anoncvs.php.  Be a bit more
	explicit who "I" is.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-langs.el:
	Rewrote the recognition function for declaration level blocks.  It should
	now cope with templates better and also be a lot more comprehensible.

	(c-looking-at-decl-block): The new function.

	(c-search-uplist-for-classkey): The old one.  It's now a wrapper for
	compatibility.

	(c-add-class-syntax, c-guess-continued-construct,
	c-guess-basic-syntax): Adapted for `c-looking-at-decl-block'.

	(c-decl-block-key): Changed to tell apart ambiguous and unambiguous
	keywords.  Pike specials are now handled directly in the code instead.

	(c-block-prefix-disallowed-chars, c-block-prefix-charset): New
	language constants and variables to make the backward skip in
	`c-looking-at-decl-block' as tight as possible.

	(c-nonsymbol-token-char-list): New language constant.

	* cc-engine.el (c-backward-<>-arglist):
	New function to find balanced template
	arglists backwards.

	* cc-defs.el (c-make-bare-char-alt):
	New helper for making char classes for
	`c-syntactic-skip-backward'.

	* cc-engine.el (c-guess-basic-syntax):
	Simplified case 16D - can't be a class-close
	at that point.

	* cc-engine.el (c-guess-basic-syntax, c-add-class-syntax):
	Don't narrow out the
	enclosing declaration level.  This makes everything a lot easier, and
	it was actually only four small places that needed it to work.  Some
	places that previously did `widen' are removed now, which has the
	effect that `c-guess-basic-syntax' never will look at things outside
	the current narrowment now.  The anchor position for `topmost-intro'
	is affected by this, but it was so bogus it was basically useless
	before, and now it's equally bogus but in a slightly different way.

	(c-narrow-out-enclosing-class): Gone.

	(c-most-enclosing-brace, c-least-enclosing-brace): Don't filter to the
	narrowed region.

	(c-least-enclosing-brace): Removed silly optional argument.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el (c-forward-keyword-clause):
	Specify which submatch to use.

	* cc-langs.el (c-symbol-start): Include '@' in ObjC.

	(c-decl-start-re): No no longer any need for special treatment of
	ObjC due to the above.

	(c-other-block-decl-kwds): Handle "extern" in ObjC too since it
	presumably follows C in that regard.

	* cc-langs.el (c-identifier-ops, c-after-id-concat-ops):
	New language constants to
	specify operator tokens inside identifiers in a more high level way.

	(c-opt-identifier-prefix-key): New internal language constant.

	(c-opt-identifier-concat-key, c-opt-after-id-concat-key,
	c-identifier-start, c-identifier-key): Now completely calculated from
	other constants.

	(c-identifier-last-sym-match): Decommissioned since it's no longer
	used.

	(c-operators): Use `c-identifier-ops'.  Documented `postfix-if-paren'.

	* cc-engine.el (c-forward-name):
	Removed the optimization when c-identifier-key is
	equal to c-symbol-key since it doesn't work in byte compiled files.
	Don't record empty regions as identifiers.

	* cc-langs.el (c-filter-ops): New helper function to simplify access to
	`c-operators' and its likes.

	(c-operator-list, c-all-op-syntax-tokens, c-nonsymbol-token-regexp,
	c-<>-multichar-token-regexp, c-<-op-cont-regexp, c->-op-cont-regexp,
	c-expr-kwds, c-primary-expr-regexp, c-cast-parens): Use it.

	* cc-defs.el (c-lang-const):
	Fixes to allow use without an explicit language in
	functions.

	* cc-defs.el (c-make-keywords-re):
	Added an appendable variant of adornment.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-any-class-key): Removed unused language variable.

	(c-type-decl-prefix-key): Removed some now unnecessary cruft from the
	Pike value.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-make-init-lang-vars-fun):
	Disabled the diagnostic message about
	precompiled language vars not being used.

	* cc-langs.el (c-paren-nontype-kwds):
	The GCC keyword "__attribute__" is followed by
	a parenthesis.

	(c-type-start-kwds, c-prefix-spec-kwds, c-prefix-spec-kwds-re,
	c-specifier-key, c-not-decl-init-keywords): Some cleanup using new
	language constants `c-type-start-kwds' and `c-prefix-spec-kwds'.
	#`c-specifier-key' has turned out to not be obsolete afterall.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el, cc-engine.el:
	Internal cleanups to properly detect the declared identifiers in
	various declarations.

	(c-decl-start-kwds): New language constant to recognize declarations
	that can start anywhere.  Used for class declarations in Pike.

	(c-specifier-key, c-not-decl-init-keywords, c-decl-prefix-or-start-re,
	c-find-decl-prefix-search, c-find-decl-spots): Implement
	`c-decl-start-kwds'.

	(c-other-decl-kwds, c-postfix-decl-spec-kwds, c-decl-hangon-kwds,
	c-decl-hangon-key, c-forward-decl-or-cast-1): Separated the handling
	of the compiler specific extension keywords into a new language
	constant `c-decl-hangon-kwds' that defines keyword clauses to be
	ignored in declarations.

	(c-forward-id-comma-list, c-forward-keyword-clause): Don't skip past
	unrecognized tokens when handling `c-colon-type-list-kwds'.  Necessary
	to stop at the declared identifier in e.g. IDL valuetype declarations.

	(c-typedef-decl-kwds, c-typeless-decl-kwds, c-type-list-kwds,
	c-prefix-spec-kwds-re, c-postfix-spec-kwds,
	c-after-suffixed-type-decl-key, c-opt-postfix-decl-spec-key,
	c-forward-decl-or-cast-1): Recognize the declared identifier in class
	and enum declarations as such and not as part of the type.
	#`c-specifier-key' is obsoleted by `c-prefix-spec-kwds-re' but is
	#still around for the time being due to some old brace list handling
	#code.

	(c-forward-decl-or-cast-1, c-forward-label): Relaxed the
	interpretation of PRECEDING-TOKEN-END when there's no preceding token.

	(c-forward-decl-or-cast-1): Don't disregard sure signs of declarations
	when there's some syntax error later on.

	(c-complex-decl-matchers): Did away with a reference to `c-specifier-key'.

	#(c-typededef-decl-kwds, c-typeless-decl-kwds, c-other-decl-kwds,
	#c-colon-type-list-re, c-decl-prefix-re, c-type-decl-prefix-key,
	#c-type-decl-suffix-key, c-after-suffixed-type-decl-key): Improved
	#docstrings.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-maybe-labelp):
	Provide no default value - this variable is always
	dynamically bound.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el, cc-menus.el, cc-mode.el, cc-styles.el, cc-vars.el, cc-align.el, cc-awk.el, cc-cmds.el, cc-defs.el:
	Changed the policy for marking up functions that might do hidden
	buffer changes: All such internal functions are now marked instead of
	those that don't.

	(c-beginning-of-macro, c-end-of-macro, c-(forward|backward)-comments,
	c-(forward|backward)-single-comment, c-parse-state, c-on-identifier,
	c-(fast-|slow-|)in-literal, c-literal-limits, c-collect-line-comments,
	c-literal-type): Allow these functions to make hidden buffer changes,
	so that they are free to use text property caching later on.

	(c-electric-backspace, c-electric-delete-forward, c-electric-pound,
	c-electric-brace, c-electric-slash, c-electric-star,
	c-electric-semi&comma, c-electric-colon, c-electric-lt-gt,
	c-electric-paren, c-electric-continued-statement, c-indent-command,
	c-indent-region, c-mask-paragraph, c-indent-new-comment-line,
	c-context-line-break): Added `c-save-buffer-state' calls to comply
	with the changed semantics of the functions above.

	* cc-engine.el (c-beginning-of-statement-1):
	Fixed a bug when macros occur in obscure
	places.  Optimized the sexp movement a bit.

	* Checklist.txt: man/cc-mode.texi should be updated too for Emacs.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el:
	Cleaned up the label handling.  Labels are now recognized in a uniform and
	more robust way, regardless of context.  Text properties are put on all
	labels to recognize the following declarations better.  Multiword labels are
	handled both in indentation and fontification for the benefit of language
	extensions like Qt.  For consistency, keywords in labels are now fontified
	with the label face instead.  That also applies to "case" and "default".

	(c-beginning-of-statement-1): Fixed some bugs in the label handling.
	Disregard `c-nonlabel-token-key' in labels that begin with
	`c-label-kwds'.
	#Also noted a bug when IGNORE-LABELS is set.

	(c-find-decl-spots): Support that the callback adds more `c-decl-end'
	spots to find.

	(c-forward-decl-or-cast-1): Don't treat a list of plain identifiers
	followed by a colon as a declaration.

	(c-forward-label): New function to recognize labels.

	(c-guess-basic-syntax): Replaced uses of `c-label-key' with
	`c-forward-label'.  Moved the label recognition cases (14 and 15)
	earlier since they aren't so context sensitive now.  Handle labels on
	the top level gracefully.  Moved access label recognition to the
	generic label case (CASE 15) - removed CASE 5E.

	#(c-fontify-recorded-types-and-refs): Some code cleanup.

	(c-font-lock-declarations): Added recognition of labels in the same
	round since we need to handle labels in parallell with other
	declarations to recognize both accurately.  It should also improve
	speed.
	#Large indentation change.

	(c-simple-decl-matchers, c-basic-matchers-after): Moved
	`c-font-lock-labels' so that it only is used on decoration level 2
	since `c-font-lock-declarations' handles it otherwise.

	(c-complex-decl-matchers): Removed the simplistic recognition of
	access labels.

	(c-decl-prefix-re): Removed the kludges that was necessary to cope
	with labels earlier.

	(c-decl-start-re): New language variable to make
	`c-font-lock-declarations' stop for the special protection labels in
	Objective-C that start with '@'.

	(c-label-key): Removed since it's no longer used.

	(c-recognize-colon-labels, c-label-prefix-re): New language constants
	to support recognition of generic colon-terminated labels.

	(c-type-decl-end-used): `c-decl-end' is now used whenever there are
	colon terminated labels.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el (c-forward-decl-or-cast-1, c-font-lock-declarations):
	Broke out the
	declaration and cast recognition from `c-font-lock-declarations' to a new
	function, so that it can be used in the indentation engine.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Checklist.txt:
	Updates and more details about de-facto procedures for releases.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-forward-<>-arglist-recur):
	Don't accept binary operators in the arglist
	if we're in a function call context, i.e. if `c-restricted-<>-arglists' is
	set.  That avoids template recognition in cases like "if (a < b || c > d)".

	(c-restricted-<>-arglists): New more appropriate name for
	`c-disallow-comma-in-<>-arglists'.

	Accessing functions updated for the variable name change.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-find-decl-spots):
	Fixed bug in backing up to the start of the
	literal.  Fixed bug with the point on the wrong side of the search
	limit that could happen when the start position is inside a literal.

	* cc-engine.el (c-parse-state, c-invalidate-state-cache):
	Modified the use of
	`c-state-cache-end' so that it's kept a little bit back to increase
	the hit rate.

	(c-parse-state): Changed the macro handling and fixed some glitches.
	Macro context is checked more often than necessary now, but otoh less
	garbage conses are generated.

	* cc-engine.el (c-parse-state, c-invalidate-state-cache):
	Cache the last position
	where `c-state-cache' applies.  This can speed up refontification
	quite a bit in blocks where there are many non-brace parens before the
	point.

	(c-state-cache-end): New variable for this.

	(c-guess-basic-syntax, c-debug-parse-state): Adapted for the new cache
	variable.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-find-decl-spots):
	Take more care to get close initial continue
	positions when the start position is inside a literal or macro.  Do
	not call the callback for spots before the start position (which can
	happen e.g. for `c-decl-end' spots inside comments).  Optimize better
	in special cases when the region is a single line inside a literal or
	macro (typically when the current line is refontified).

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax):
	Simplified calls to `c-add-stmt-syntax' -
	there's no need to explicitly whack off entries from the paren state.

	* cc-engine.el (c-add-stmt-syntax):
	Narrowed down the special case for "else if"
	clauses.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-looking-at-inexpr-block, c-add-stmt-syntax): Use
	`c-recognize-paren-inexpr-blocks'.

	* cc-langs.el (c-recognize-paren-inexpr-blocks):
	New language variable to recognize
	the gcc extension with statement blocks inside expressions.

	* cc-engine.el (c-add-stmt-syntax):
	Restructured to make it somewhat more
	comprehensible.  The argument AT-BLOCK-START is no longer used and
	hence removed.

	(c-guess-continued-construct, c-guess-basic-syntax): Updated calls to
	`c-add-stmt-syntax'.

	* cc-engine.el (c-beginning-of-statement-1):
	Don't allow parens in labels.

	(c-backward-to-decl-anchor): Use `c-beginning-of-statement-1' instead
	of duplicating parts of it.  This fixes bogus label recognition.

	* cc-engine.el (c-backward-to-decl-anchor):
	Use `c-beginning-of-statement-1' instead
	of duplicating parts of it.  This fixes bogus label recognition.

	* cc-mode.texi:
	Extended the doc on c-label-minimum-indentation a little.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-add-type, c-check-type, c-forward-name, c-forward-type):
	Improved
	storage of template types in `c-found-types' so that they can be
	recognized better.

	(c-syntactic-content): Added option to skip past nested parens.

	* cc-engine.el (c-forward-name):
	Set `c-last-identifier-range' all the time.  It's
	less work that way.  Handle that there might not be an identifier to
	store in `c-last-identifier-range'.

	(c-forward-type): Handle that `c-last-identifier-range' might be nil
	from `c-forward-name'.

	* cc-defs.el:
	(c-safe-scan-lists, c-(go-)?(up|down)-list-(forward|backward)): Added
	limit arguments.

	* cc-defs.el (c-save-buffer-state):
	Use `unwind-protect' to work even if the form
	fails.

	* cc-engine.el (c-parse-state):
	Speedup when moving far down in a large file in one
	go.

	(c-get-fallback-start-pos): New helper function for `c-parse-state'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi: Document c-lineup-assignments and c-lineup-math.

	* cc-align.el (c-lineup-assignments): New lineup function which is like
	`c-lineup-math' but returns nil instead of `c-basic-offset' when it
	doesn't match.

	(c-lineup-math): Changed to use `c-lineup-assignments'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-langs.el:
	Use `c-simple-ws' instead of hardcoded char classes whereever possible.
	Changed a couple of places to use skip by syntax instead of skip by char
	class.

	* cc-langs.el (c-unterminated-block-comment-regexp):
	Fixed a bug in the regexp that
	caused extreme backtracking.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-block-comment-starter, c-block-comment-ender):
	New language
	constants to specify in a single place how block comments look.

	(c-comment-start-regexp, c-block-comment-start-regexp, comment-start,
	comment-end, comment-start-skip, c-syntactic-ws-start,
	c-syntactic-ws-end, c-nonwhite-syntactic-ws, c-syntactic-ws,
	c-nonempty-syntactic-ws, c-single-line-syntactic-ws, c-syntactic-eol):
	Now built from `c-line-comment-starter', `c-block-comment-starter' and
	`c-block-comment-ender'.

	(c-block-comment-regexp, c-unterminated-block-comment-regexp): New
	language constants to break up things a bit.

	(c-simple-ws): New language constant for simple whitespace.

	#(c-known-type-key): Slight clean up using `c-concat-separated'.

	* cc-defs.el (c-concat-separated): New convenience function.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-known-type-key): Optimize simple symbols from
	`*-font-lock-extra-types' so that there's no need to use `regexp-opt'
	on those lists.

	* cc-langs.el (c-type-decl-suffix-key):
	Fix when `c-type-modifier-kwds' is empty.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-invalid-string):
	Fix when there are several strings on
	the same line.

	* cc-engine.el (c-literal-limits):
	Removed the compatibility function for older
	emacsen.  `c-literal-limits-fast' has now taken the place of this
	function.

	* cc-vars.el (c-emacs-features):
	Removed compatibility with older emacsen: We now
	require 'pps-extended-state.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-fonts.el, cc-langs.el (c-guess-basic-syntax):
	Changed the way class-level labels are recognized;
	they can now contain essentially any symbols.

	(c-opt-extra-label-key): New language variable to cope with the special
	protection label syntax in Objective-C.

	(c-opt-access-key): Removed; this is now handled better by
	`c-nonlabel-token-key' and `c-opt-extra-label-key'.

	(c-complex-decl-matchers): Update to handle that `c-opt-access-key' no
	longer exists.

	* cc-engine.el (c-guess-basic-syntax):
	Make use of the improved label recognition in
	`c-beginning-of-statement-1'.

	* cc-engine.el (c-beginning-of-member-init-list):
	Recognize bitfields better.
	#Also a bit cleaned up.

	#(c-guess-basic-syntax): Cleaned up a couple of cases and changed to
	#slightly faster methods.

	* cc-engine.el (c-beginning-of-inheritance-list):
	Removed some cruft and fixed a bug
	that could cause it to go to a position further down.

	* cc-langs.el, cc-engine.el (c-beginning-of-statement-1):
	Improved detection of labels in declaration
	contexts.

	(c-beginning-of-decl-1): Use it.

	(c-nonlabel-token-key): New language constant and variable needed by
	`c-beginning-of-statement-1'.

	* cc-engine.el (c-guess-basic-syntax):
	Fixed bug that manifested itself due to the
	correction in `c-forward-sexp'.

	* cc-defs.el (c-forward-sexp, c-backward-sexp):
	Made these behave as documented
	when used at the buffer limits.

	* cc-mode.el, cc-engine.el, cc-langs.el (c-type-decl-end-used):
	Made this a language variable.

	* cc-mode.el (c-after-change): Widen the buffer to work correctly when
	`combine-after-change-calls' is used together with temporary
	narrowings.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1):
	Report labels correctly when the start
	point is immediately after the colon.
	#Extended and reformatted the local variable comments a bit.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-parse-sexp-lookup-properties):
	Removed since it isn't used anymore.

	* cc-cmds.el (c-electric-lt-gt):
	Detect and mark angle bracket arglists such as
	template parens in C++.

	* cc-engine.el (c-syntactic-skip-backward):
	Fixed a bug in the last check-in.  Some
	optimization.

	* cc-engine.el (c-syntactic-skip-backward):
	Fixed bug where it could stop at the same
	level in a preceding sexp when PAREN-LEVEL is set.

	* cc-mode.el (c-basic-common-init):
	Turn on syntax-table text property lookup only
	when it's needed.

	* cc-langs.el, cc-engine.el, cc-fonts.el, cc-mode.el:
	Changed the policy for paren marked angle brackets to be more persistent;
	once marked they remain marked even when they're found to be unbalanced in
	the searched region.  This should keep the paren syntax around even when
	individual lines are refontified in multiline template arglists.

	(c-parse-and-markup-<>-arglists): New dynamically bound variable to control
	markup so that incorrect angle bracket arglists aren't marked in contexts
	where the correct value for `c-disallow-comma-in-<>-arglists' isn't known.

	(c-forward-<>-arglist, c-forward-<>-arglist-recur): The reparse argument has
	become `c-parse-and-markup-<>-arglists'.

	(c-remove-<>-arglist-properties): Removed - no longer used.

	(c-after-change-check-<>-operators): New function used on
	`after-change-functions' to avoid that "<" and ">" characters that are part
	of longer operators have paren syntax.

	(c-<>-multichar-token-regexp): New language variable used by
	`c-after-change-check-<>-operators'.

	(c-after-change): Call `c-after-change-check-<>-operators'.

	(c-font-lock-<>-arglists): Use the context properties set by
	`c-font-lock-declarations' to set `c-disallow-comma-in-<>-arglists'
	correctly to avoid doing invalid markup.

	(c-font-lock-declarations): Removed code that undoes the invalid markup done
	by `c-font-lock-<>-arglists'.

	(c-complex-decl-matchers): `c-font-lock-<>-arglists' now runs after
	`c-font-lock-declarations'.

	#(c-beginning-of-current-token): A little too large and used a little too
	#often to be a defsubst.
	#
	#(c-syntactic-skip-backward): Fixed bug detected by the byte compiler.
	#
	#(c-font-lock-objc-iip-decl): Updated for changes in `c-forward-<>-arglist'.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-skip-backward): Added paren-level feature.

	(c-guess-basic-syntax): Improved the anchor position for
	`template-args-cont' in nested template arglists.  There's still much
	to be desired in this area, though.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.texi:
	Some updates due to the dropping of the support for older emacsen.

	* cc-defs.el, cc-engine.el (c-mode-is-new-awk-p):
	Removed; (c-major-mode-is 'awk-mode) can be used
	instead now.

	* cc-mode.el:
	Always set up AWK mode since emacsen where it doesn't work no longer
	are supported.

	* cc-mode.el, cc-styles.el, cc-vars.el, cc-defs.el, cc-engine.el, cc-fonts.el, cc-langs.el, cc-cmds.el:
	CC Mode now requires support for the syntax-table' text property, which
	rules out Emacs 19 and XEmacs < 21.4.  Removed various compatibility cruft
	associated with those versions.

	* cc-defs.el, cc-fix.el:
	CC Mode now requires support for the `syntax-table' text property, which
	rules out Emacs 19 and XEmacs < 21.4.  Removed various compatibility cruft
	associated with those versions.

	* cc-vars.el (c-emacs-features): CC Mode now requires support for the
	`syntax-table' text property.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-nonbreakable-space-face):
	Remove the variable and use an extra
	quoted face name instead.  All the emacsen flavors handle that
	correctly.

	* Checklist.txt: Added a note.

	* Release.py: Makefile no longer contains a literal version number.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Release.py:
	Put a branch tag on each release, in addition to the release tag.

2005-06-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Checklist.txt: Describe the handling of the patch branch.

2005-05-24  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.45 released.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Patch release 5.30.10.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-invalid-face-name): Use "red1" instead of "red"
	since it stands out better in xterms and DOS terminals.  Original
	change by Dan Nicolaescu <dann@ics.uci.edu>.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarators): Fixed bug where the point
	could go past the limit in decoration level 2, thereby causing
	errors during interactive fontification.  (This is, in fact, the
	Right fix for the problem that has plagued JDEE users.)

2005-05-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el, cc-engine.el, cc-align.el: Change the FSF's address
	in the copyright statement.  Incidentally, change "along with GNU
	Emacs" to "along with this program" where it occurs.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-make-inherited-keymap): Fixed cc-bytecomp bug when
	the file is evaluated interactively.

2005-05-23  Kevin Ryde  <user42@zip.com.au>:

	* cc-align.el (c-lineup-argcont): Ignore conses for {} pairs from
	c-parse-state, to avoid a lisp error (on bad code).

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Handle operator
	declarations somewhat better in C++.

2005-05-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-mode.el: Add a fourth parameter `t' to the awk-mode autoload,
	so that it is interactive, hence can be found by M-x awk-mode
	whilst cc-mode is yet to be loaded.  Reported by Glenn Morris
	<gmorris+emacs@ast.cam.ac.uk>.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-styles.el, cc-mode.el (c-run-mode-hooks): New helper macro to
	make use of `run-mode-hooks' which has been added in Emacs 21.1.

	(c-mode, c++-mode, objc-mode, java-mode, idl-mode, pike-mode,
	awk-mode): Use it.

	(make-local-hook): Suppress warning about obsoleteness which has
	been added in Emacs 21.1.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el, cc-align.el, cc-cmds.el
	(c-append-backslashes-forward, c-delete-backslashes-forward,
	c-find-decl-spots, c-semi&comma-no-newlines-before-nonblanks):
	Compensate for return value from `forward-line' when it has moved
	but not to a different line due to eob.

2005-05-23  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed anchoring in
	`objc-method-intro' and `objc-method-args-cont'.

2005-05-23  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-awk.el: Add character classes (e.g. "[:alpha:]") into AWK
	Mode's regexps.

2005-05-20  Aidan Kehoe  <kehoea@parhasard.net>

	* cc-engine.el (c-syntactic-re-search-forward): Revert my last
	change, it's the wrong thing. 
	* cc-fonts.el (c-font-lock-declarators): Apply Michael Thome's fix
	of 42404C6D.1030705@bbn.com, which is the Right Thing, once you've
	signed up for the re-search-forward API, which isn't great, IMO. 

2005-05-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.44 released.

2005-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* cc-engine.el (c-syntactic-re-search-forward): Before the first
	call of re-search-forward in the function, make sure that the
	bound is greater than or equal to (point). Fixes an error:

	Error caught in `font-lock-pre-idle-hook': (error Invalid search
	limit (wrong side of point))

	that users of JDEE have been seeing for a long time. 

2004-08-12  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.43 released.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Patch release 5.30.9.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el, cc-vars.el (c-emacs-features): Moved from cc-vars to
	cc-defs for dependency reasons.  Fixed the POSIX char class test
	to check that it works in `skip-chars-(forward|backward)' too.

	* cc-align.el (c-lineup-arglist): Fixed bug when the first
	argument starts with a special brace list.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-forward-type): Fixed promotion bug when
	`c-opt-type-concat-key' is used (i.e. in Pike).

	* cc-engine.el (c-looking-at-special-brace-list): Fixed bug when
	the inner char pair doesn't have paren syntax, i.e. "(< >)".

2004-08-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el, cc-vars.el: Amend doc(-strings) to say that <TAB>
	doesn't insert WS into a CPP line.
	(c-indent-command, c-tab-always-indent): Amend doc strings.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-multi-inher): Made it syntactic whitespace
	safe.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed similar situations
	for `arglist-cont-nonempty' and `arglist-close'.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed anchor position for
	`arglist-intro' when there are two arglist open parens on the same
	line and there's nothing in front of the first.

	* cc-fonts.el (c-basic-matchers-before): Fixed font locking of
	qualified names in Java, which previously could fontify common
	indexing expressions in many cases.  The standard Java naming
	conventions are used to tell them apart.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-align.el (c-lineup-whitesmith-in-block): Fixed inconsistency
	wrt opening parens on the first line inside a paren block.

	* cc-defs.el (c-langs-are-parametric): Must be known at compile
	time for the sake of `c-major-mode-is'.

	(c-mode-is-new-awk-p): Made it a macro to delay expansion of
	`c-major-mode-is' in the event that this is used inside a
	`c-lang-defconst'.

2004-08-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-styles.el, cc-engine.el: Add in two checks for user errors,
	thus eliminating cryptic and unhelpful Emacs error messages.  (1)
	Check the arg to `c-set-style' is a string.  (2) Check that
	settings to `c-offsets-alist' are not spuriously quoted.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-major-mode-is): Fixed expansion inside
	`c-lang-defconst' so that it works better with fallback languages.

	* cc-defs.el (c-add-language): Fixed a typo that caused it to fail
	to record the base mode.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fixed bug so that
	it doesn't go past the closing paren when PAREN-LEVEL is used.
	Reordered the syntax checks to get more efficient skipping in some
	situations.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Don't trip up on a line
	continuation which might precede the newly inserted '{'.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fixed cases where
	it could loop indefinitely.

2004-08-11  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-cmds.el: (c-electric-brace): don't delete a comment which
	precedes the newly inserted `{'.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarators): Handle array size specs
	correctly.  Only fontify identifiers in front of '(' with as
	functions - don't accept any paren char.  Tightened up initializer
	skipping to stop before function and class blocks.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-decl-1): Fixed bug where the point
	could be left directly after an open paren when finding the
	beginning of the first decl in the block.

	* cc-engine.el (c-parse-state): Don't use the syntax table when
	filtering out legitimate open parens to be recorded.  This could
	cause cache inconsistencies when e.g. `c++-template-syntax-table'
	was temporarily in use.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-on-identifier, c-simple-skip-symbol-backward):
	Small fix for handling "-" correctly in `skip-chars-backward'.
	Affected the operator lfun syntax in Pike.

2004-08-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-invalidate-sws-region-after): Fixed bug that
	could cause an error from `after-change-functions' when the
	changed region is at bob.

2003-11-18  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.42 released.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Patch release 5.30.8.

	* cc-engine.el (c-guess-continued-construct,
	c-guess-basic-syntax): Check a little more carefully if it's a
	function declaration when an unknown construct followed by a block
	is found inside a statement context.  This avoids macros followed
	by blocks to be taken as function declarations.

	(c-guess-continued-construct): Changed the analysis of a statement
	continuation with a brace open to `substatement-block', for
	consistency with recognized statements.

	(c-add-stmt-syntax): Don't continue to the surrounding sexp if the
	start is in a position so that `c-beginning-of-statement-1' jumped
	to the beginning of the same statement.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el, cc-engine.el (c-forward-<>-arglist-recur): Don't
	accept binary operators in the arglist if we're in a function call
	context, i.e. if `c-restricted-<>-arglists' is set.  That avoids
	template recognition in cases like "if (a < b || c > d)".

	(c-restricted-<>-arglists): New more appropriate name for
	`c-disallow-comma-in-<>-arglists'.

	Accessing functions updated for the variable name change.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-syntactic-re-search-forward): Fix bug where the
	match data could get clobbered if NOT-INSIDE-TOKEN is used.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-statement-1): Don't allow parens in
	labels.

	(c-backward-to-decl-anchor): Use `c-beginning-of-statement-1'
	instead of duplicating parts of it.  This fixes bogus label
	recognition.

	* cc-align.el (c-gnu-impose-minimum): Reverted to the old method
	of checking the context in which to apply the minimum indentation,
	so that it isn't enforced in e.g. namespace blocks.

	* cc-vars.el (c-inside-block-syms): New constant used by
	`c-gnu-impose-minimum'.  It's defined close to `c-offsets-alist'
	to somewhat reduce the risk of becoming stale.

	* cc-cmds.el, cc-engine.el (c-shift-line-indentation): Moved from
	cc-cmds to cc-engine to allow use from cc-align.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-beginning-of-inheritance-list): Cope with fully
	qualified identifiers containing "::".

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-make-keywords-re): Added kludge for bug in
	`regexp-opt' in Emacs 20 and XEmacs when strings contain newlines.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-emacs-features): Use a space in front of the name
	of the temporary buffer.  That also avoids dumping problems in
	XEmacs due to undo info being left around after the buffer is
	killed.

2003-11-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-in-knr-argdecl): Look closer at the function
	arglist to see if it's a K&R style declaration.

	(c-guess-basic-syntax): CASE 5B.2: Check with `c-in-knr-argdecl'
	before returning `knr-argdecl-intro'.

2003-10-31  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.41 released.

2003-09-25  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.40 released.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-parse-state): Fixed bug that could cause errors
	when the state cache contains info on parts that have been
	narrowed out.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-comment-prefix-regexp): Document that
	`c-setup-paragraph-variables' has to be used when this variable is
	changed; it doesn't work to reinitialize the mode since that
	typically clobbers the variable.

	* cc-styles.el (c-setup-paragraph-variables): Made it interactive.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-declarations): Fixed recognition of
	constructors and destructors for classes whose names are matched
	by `*-font-lock-extra-types'.

	* cc-langs.el (c-type-list-kwds): If "operator" is followed by an
	identifier in C++ then it's a type.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (c-font-lock-invalid-string): Fixed eob problem that
	primarily affected XEmacs.  Don't use faces to find unterminated
	strings since Emacs and XEmacs fontify strings differently - this
	function should now work better in XEmacs.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Fixed a bug in the
	`expand-abbrev' workaround which caused braces to disbehave inside
	macros.

	* cc-engine.el (c-forward-keyword-clause): Fixed error handling.
	This bug could cause interactive font locking to bail out.

2003-09-24  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-just-after-func-arglist-p): Handle paren-style
	types in Pike.  Also fixed some cases of insufficient handling of
	unbalanced parens.

2003-08-26  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.39 released.

2003-08-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-cmds.el (c-electric-brace): Work around for a misfeature in
	`expand-abbrev' which caused electric keywords like "else" to
	disappear if an open brace was typed directly afterwards.

2003-08-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-vars.el (c-extra-types-widget): The doc string is mandatory
	in `define-widget'.

	* cc-align.el, cc-langs.el (c-lineup-math): Don't align the
	operators "!=", "<=" and ">=" as assignment operators.

	(c-assignment-operators): New language constant that only contains
	the assignment operators.

	(c-assignment-op-regexp): New language variable used by
	`c-lineup-math'.

2003-08-26  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-just-after-func-arglist-p): Safeguard against
	unbalanced sexps.

2003-08-03  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.38 released.

2003-08-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-mode.el (c-init-language-vars-for): Add argument MODE.
	Renamed from c-init-c-language-vars'.
	(c-initialize-cc-mode): Change accordingly.
	(c-common-init): Ditto.
	(c-mode): Ditto.
	(c++-mode): Use function.
	(objc-mode): Ditto.
	(java-mode): Ditto.
	(idl-mode): Ditto.
	(pike-mode): Ditto.
	(awk-mode): Ditto.

2003-08-01  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-end-of-current-token): Return whether or not the
	point moved.

	(c-search-decl-header-end): Don't trip up on operator identifiers
	in C++ and operators like == in all languages.

	* cc-engine.el (c-backward-to-decl-anchor): Detect leading labels
	correctly.

2003-07-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.37 released.

2003-07-16  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-defs.el (c-langelem-sym, c-langelem-pos, c-langelem-2nd-pos):
	Added accessor functions for syntactic elements.

2003-07-09  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-literal-faces): Declare as a variable since it
	might be modified.

	* cc-langs.el: (c++-make-template-syntax-table,
	c-syntactic-ws-start, c-syntactic-ws-end): Gave more consistent
	names to these language constants.

2003-07-08  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-engine.el (c-guess-basic-syntax): Do not do hidden buffer
	changes; there's third party code that calls this function
	directly.

2003-07-07  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-fonts.el (javadoc-font-lock-keywords,
	autodoc-font-lock-keywords): Don't byte compile on font lock
	initialization when running from byte compiled files.

2003-07-06  Alan Mackenzie  <bug-cc-mode@gnu.org>

	* cc-engine.el: Fix AWK mode indentation when previous statement
	ends with auto-increment "++".

2003-07-06  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.36 released.

2003-07-05  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el, cc-styles.el (c-style-alist, c-lang-variable-inits,
	c-lang-variable-inits-tail): The values of these are changed, so
	declare them as variables and not constants.

	* cc-mode.el: Fixed some autoload problems: Try to ensure that the
	entry for ".c" extension comes before the one for ".C" on
	`auto-mode-alist', to behave better on case insensitive OS:es.
	Fixed incorrect entries that were added to
	`interpreter-mode-alist'.  Moved the autoload directives for AWK
	to the top level since they aren't recognized anywhere else.  Do
	not use the new AWK mode doc in the autoload form for the old AWK
	mode.

2003-07-04  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.35 released.

2003-07-03  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* Update to CC Mode 5.30.

2003-04-02  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.33 released.

2003-04-01  Steve Youngs  <youngs@xemacs.org>

	* Makefile (ELCS): Don't build cc-make.el or cc-mode-19.el.
	Rename both to *.upstream.
	(PRELOADS): Add cc-bytecomp.el.

2003-03-09  Ben Wing  <ben@xemacs.org>

	* Makefile:
	Delete explicit compile:: and binkit: rules.
	Don't add custom-load.elc to the list of generated elc's.
	Use STANDARD_DOCS instead of explicitly giving the targets
	and dependencies.
	Move the include of XEmacs.rules to the end of the file.

2003-01-13  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.32 released.

2003-01-06  Ville Skyttä  <scop@xemacs.org>

	* cc-mode.el: Make auto-mode-alist modifications autoload-only.

2002-11-29  Ben Wing  <ben@xemacs.org>

	* .cvsignore: Remove files now handled automatically by CVS.
	* Makefile: Use `compile' instead of hard-coded `all'.

2002-10-15  Ville Skyttä  <scop@xemacs.org>

	* Makefile (srckit): Remove.

2002-10-14  Ville Skyttä  <scop@xemacs.org>

	* Makefile (MANUAL): Removed (unused).

2002-10-07  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.31 released.

2002-09-30  Ville Skyttä  <scop@xemacs.org>

	* cc-mode.el: Add autoloaded auto-mode-alist associations.

2002-09-06  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.30 released.

2002-08-31  Ville Skyttä  <scop@xemacs.org>

	* cc-engine.el (c-parse-state): Fix problem in finding
	out the parenthesis state around the indentation position.
	Patch from Martin Stjernholm (author).

2002-08-02  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.29 released.

2002-08-01  Ville Skyttä  <scop@xemacs.org>

	* cc-engine.el (c-beginning-of-member-init-list):
	Apply patch from Martin Stjernholm submitted by Neal D. Becker,
	Martin's comments: CC Mode 5.28 has a bug that causes it to
	confuse < and > in such initialization lists with template
	parentheses.  The following patch corrects that.

2002-07-16  Adrian Aichner  <adrian@xemacs.org>

	* .cvsignore: Add generated .info* and .html files.

2002-05-09  Steve Youngs  <youngs@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.28 released.

2002-05-08  Steve Youngs  <youngs@xemacs.org>

	* Makefile (PRELOADS): No need to push the current directory into
	the load-path.

2002-01-13  Steve Youngs  <youngs@xemacs.org>

	* package-info.in (provides): Update to include all provides.

2002-01-07  Adrian Aichner  <adrian@xemacs.org>

	* Makefile (HTML_FILES): New.
	* Makefile (HTML_DEP): New.

2001-08-13  Enrico Scholz  <enrico.scholz@informatik.tu-chemnitz.de>

	* cc-cmds.el (c-fill-paragraph): Use 'c-current-comment-prefix'.

2001-05-11  Martin Stjernholm  <bug-cc-mode@gnu.org>

	* cc-langs.el (c-switch-label-key): Regexp fix.

2001-02-24  Ben Wing  <ben@xemacs.org>

	* Makefile (MANUAL):
	Conditionalize extra MS Windows quoting on
	XEMACS_NATIVE_NT_NEEDS_EXTRA_QUOTING, since it breaks things under
	newer Cygwins.

2001-02-28  Steve Youngs  <youngs@xemacs.org>

	* Makefile (REQUIRES): Add mail-lib.
	(ELCS): Add missing .elc files.

	* Import cc-mode 5.28.

2000-11-07  Martin Buchholz <martin@xemacs.org>

	* cc-mode.texi: Doc fix.

2000-10-05  Martin Buchholz  <martin@xemacs.org>

	* *: Mega typo fix.

2000-07-26  Ben Wing  <ben@xemacs.org>

	* Makefile (PRELOADS): correct command-line quoting for MS Windows
	native.

2000-07-10  Andreas Jaeger  <aj@suse.de>

	Release 5.27 downloaded from http://cc-mode.sourceforge.net/.

1998-12-30  Martin Buchholz  <martin@xemacs.org>

	* Makefile (MAINTAINER): The preferred address is bug-cc-mode@gnu.org

	* Release 5.25
	Snarfed from http://www.python.org/emacs/cc-mode/

1998-03-05  SL Baur  <steve@altair.xemacs.org>

	* cc-mode.el: cc-defs isn't needed at run-time.

	* Synch with 5.21

1998-02-11  SL Baur  <steve@altair.xemacs.org>

	* cc-mode.el: Correct dependency on cc-defs (needs to be before
	use of `c-safe' macro.

Sun Feb  8 15:30:43 1998  Barry A. Warsaw  <cc-mode-help@python.org>

	* Release 5.20

Wed Feb 04 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-mode.el (c-mode, c++-mode, objc-mode, java-mode): set
	imenu-case-fold-search to nil.

Tue Feb 03 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-langs.el (c-postprocess-file-styles): If a file style or file
	offsets are set, make the variables local to the buffer (via
	make-local-variable).

	* cc-styles.el (c-make-styles-buffer-local): Take an optional
	argument which switches between make-variable-buffer-local and
	make-local-variable.  Generalize.

Mon Feb 02 1998  Martin Stjernholm  <cc-mode-help@python.org>

	* cc-align.el (c-lineup-close-paren, c-indent-one-line-block): New
	indentation functions.

	* cc-cmds.el (c-beginning-of-statement, c-end-of-statement): Do
	not move by sentence in strings.  Doc fixes.

	* cc-mode.texi: Document new indentation functions.

Sat Jan 24 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-defs.el (c-point): In XEmacs, use scan-lists +
	buffer-syntactic-context-depth to radically speed up locating
	top-level defun opening brace in some situations.  When the braces
	hang, this can make c-parse-state from between 3 to 60 times
	faster.  When they don't hang, this may be a few percentage points
	slower (not noticeable to me though).  The variable
	c-enable-xemacs-performance-kludge-p toggles the behavior.  This
	change has no effect on Emacs, which lacks the built-in function
	buffer-syntactic-context-depth.

	* cc-mode.texi: Discuss c-enable-xemacs-performance-kludge-p in
	the section on performance.

	* cc-vars.el (c-enable-xemacs-performance-kludge-p): New variable.

Fri Jan 23 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el cc-defs.el cc-engine.el (c-beginning-of-defun,
	c-indent-defun, c-parse-state): Use (c-point 'bod) instead of
	beginning-of-defun directly.

Tue Jan 20 1998  Martin Stjernholm  <cc-mode-help@python.org>

	* cc-cmds.el (c-beginning-of-statement): Speedup; it's only
	necessary to call `c-literal-limits' once when the function is
	entered.

Mon Jan 19 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-align.el (c-semi&comma-no-newlines-before-nonblanks,
	c-semi&comma-no-newlines-for-oneline-inliners): New functions,
	appropriate for c-hanging-semi&comma-criteria, but not placed on
	that variable by default.

	* cc-langs.el (c-mode-base-map): Comment out c-beginning-of-defun
	and c-end-of-defun bindings, since RMS doesn't want these to be
	the default.

	* cc-mode.texi: Describe c-beginning-of-defun and c-end-of-defun.
	Describe the new c-hanging-semi&comma-criteria functions.

Sun Jan 18 1998  Martin Stjernholm  <cc-mode-help@python.org>

	* cc-cmds.el (c-beginning-of-statement): Handle multiple C++ line
	comments a little better.

	Almost completely rewritten.  It's now more thorough when handling
	strings and comments and the transitions between them and the
	surrounding code.  The statement parsing is also rewritten because
	`c-{beginning|end}-of-statement-1' does no longer do what we want
	in this function (e.g. c-b-o-s-1 doesn't go into blocks).  It also
	works better for different counts and when sentence-flag is nil.

	* cc-engine.el (c-forward-syntactic-ws, c-backward-syntactic-ws):
	Removed the narrowings which doesn't seem to have much effect.
	Instead a simple check is made against the given limit.  In
	`c-backward-syntactic-ws' this means that there's no need to
	search for bod, which helps up speed quite a lot in some areas.

	(c-collect-line-comments): New function that given the limits of
	one C++ style line comment returns the range for all adjacent line
	comments.  This functionality is moved from the functions
	`c-literal-limits' and `c-literal-limits-fast'.

	(c-literal-limits): New function that finds the start and end pos
	of a comment or string surrounding point.  This function is Emacs
	19.34 compatible and it has a workaround for what seems to be a
	bug in `parse-partial-sexp' when we use an existing state to get
	the state for the very next character.

	(c-literal-limits-fast): A faster variant of `c-literal-limits'
	for newer Emacsen where the state returned from
	`parse-partial-sexp' contains the starting pos of the last
	literal.  This does not contain the workaround described above.
	The function is not yet tested and therefore not in use for now.
	Note that these functions regard the position between the first
	and second char of a comment starter to be part of the comment.
	Although `parse-partial-sexp' (in Emacs 19 anyway) doesn't do
	this, it seems more intuitive to me.  Maybe `c-in-literal' should
	do this too?

Thu Jan 15 1998  Martin Stjernholm  <cc-mode-help@python.org>

	* cc-mode-19.el Added `when' and `unless'.

Thu Jan 15 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-engine.el (c-guess-basic-syntax): Fixed a few byte compiler
	warnings.

Wed Jan 14 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-beginning-of-defun, c-end-of-defun): New commands
	which mimic the standard built-ins, but do a much better job of
	finding the open brace when it's hung on the right side (as is the
	case with the most common Java style).

	* cc-engine.el (c-backward-to-start-of-do): Break infloop for
	illegal code, e.g. when someone types while (TRUE) { at the top of
	a buffer, we shouldn't hang when the { is typed!

Tue Jan 13 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-beginning-of-statement): When moving forward by
	sentences, because we're either inside or at the start of a
	comment, be sure to limit movement to only within the extent of
	the comment.

Sat Jan 10 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-langs.el (c-java-method-key): I really don't remember why
	this was added, but it seems to do more harm than good.  Besides,
	its value was clearly wrong, being inherited from Objective-C.

	* cc-mode.el (java-mode): Set c-method-key to nil.  I don't think
	this is necessary for Java, and besides, the old value was
	inherited from Objective-C which was clearly not right.  With this
	change, all regression tests pass and the example by Bengt
	Martensson also passes:

	class Baz
	{
	    int blah()
	    {
		return 1
		    + 2
		    + 3
		    + foobar()
		    + 5
		    + 6;
	    }
	}

	* cc-mode.texi Add some explanation to "gnu" style and "user"
	style, describing the relationship between these and user
	Customizations.

	* cc-vars.el (c-default-style): Change this back to "gnu" after
	(re-reading old) discussions with RMS.  This may confuse users who
	set variables in the top-level of their .emacs files, or using the
	Custom interface, since those changes will get incorporated into
	the "user" style.  RMS insists, however, that the default style be
	"gnu".

Sun Jan 04 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-electric-colon): Newlines should not be inserted
	before or after scope operators, regardless of the value of
	c-hanging-colons.

	* cc-engine.el (c-backward-to-start-of-if): Workaround a nasty to
	track down bug.  If point is < lim, then this function can
	actually land you forward into the buffer.  This can cause an
	infloop in c-beginning-of-statement-1. It is probably a bug that
	this function gets called with a lim > point, but that's even
	harder to figure out, so if that's the case when this function is
	called, it's simpler just to ignore lim and use bod.  This breaks
	the infloop without causing broken indentation.

Sat Jan 03 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-align.el (c-lineup-dont-change): New lineup function that
	leaves the current line's indentation unchanged.  Used for the new
	cpp-macro-cont syntactic symbol.

	* cc-cmds.el (c-electric-brace): namespace-open and
	namespace-close braces can hang.

	* cc-defs.el (c-emacs-features): Added autoload cookie which Steve
	Baur claims is necessary for XEmacs.

	* cc-engine.el (c-search-uplist-for-classkey): When searching up
	for a class key, instead of hardcoding the extended search for
	"extern", use the new variable c-extra-toplevel-key, which is
	language dependent.  For C++, this variable includes the keyword
	"namespace" which will match C++ namespace introducing blocks.

	(c-guess-basic-syntax): Support for recognizing C++ namespace
	blocks, by elaborating on the mechanism used to find external
	language blocks.  Searches which hardcoded "extern" now use
	c-extra-toplevel-key, a language dependent variable.  Case clauses
	that were modified: CASE 5A.1, CASE 5A.4, CASE 5F, CASE 5I, CASE
	14A.

	CASE 3: we can now determine whether we're at the beginning of a
	cpp macro definition, or inside the middle of one. Set syntax to
	'cpp-macro in the former case, 'cpp-macro-cont in the latter.  In
	both cases, the relpos is the beginning of the macro.

	(c-forward-syntactic-ws): Added code that skips forward over
	multi-line cpp macros.

	(c-beginning-of-macro): Moved, and made into a defsubst.  This
	function can now actually find the beginning of a multi-line C
	preprocessor macro.

	(c-backward-syntactic-ws): Use c-beginning-of-macro to skip
	backwards over multi-line macro definitions.

	(c-in-literal, c-fast-in-literal): Use c-beginning-of-macro to
	find out whether we're in a multi-line macro definition.

	* cc-langs.el (c-C-extra-toplevel-key, c-C++-extra-toplevel-key,
	c-extra-toplevel-key): New variables which parameterize the search
	for additional top-level enclosing constructs.  In all languages,
	extern lang blocks are supported (but maybe this should just be C
	and C++?). In C++, also namespace blocks are supported.

	* cc-menus.el Imenu patches by Masatake Yamato and Jan Dubois.

	* cc-mode.el (c++-mode): Set c-extra-toplevel-key to
	c-C++-extra-toplevel-key.

	(c-initialize-on-load): New variable, *not* customized.  When set
	to t -- the default -- c-initialize-cc-mode is called when the
	cc-mode.el file is loaded, e.g. via (require 'cc-mode).  This is
	backwards compatible with .emacs files that used CC Mode 4.  I'm
	still not 100% sure this is the right thing to do.

	* cc-mode.texi: Added descriptions of the new C++ namespace
	syntactic symbols: namespace-open, namespace-close, innamespace.
	Added an example for this and also multi-line macros.

	Describe c-lineup-dont-change and the new cpp-macro-cont syntactic
	symbol.  Remove the `known limitation' that multi-line macros
	aren't supported.

	* cc-styles.el (c-offsets-alist): Three new syntactic symbols:
	innamespace, namespace-open, namespace-close.  These support C++
	namespace blocks.

	Added new syntactic symbol cpp-macro-cont, by default bound to
	c-lineup-dont-change.  This symbol is assigned to subsequent lines
	of a multi-line C preprocess macro definition.

	* cc-vars.el (c-default-style): Variable is user customizable so
	it's docstring should start with a `*'.

Fri Jan 02 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-engine.el (c-fast-in-literal): Function which should be
	faster than c-in-literal.  This uses buffer-syntactic-context
	which is a speedy built-in that exists only in XEmacs.  Make it's
	alias conditional on that built-in's existance.  To be honest, the
	performance effects should be tested.  Also c-fast-in-literal
	knows about multi-line cpp macros while c-in-literal does not.
	The latter should be taught about this, but this change will wait
	for a future mega-patch to handle multi-line macros.

Thu Jan 01 1998  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-comment-line-break-function): When breaking a
	line-oriented comment, copy the comment leader from the previous
	line instead of hardcoding it to "// ".  This ensures that
	whitespace between the slashes and the text is preserved.

Tue Nov 18 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-langs.el (c-mode-base-map): Bind c-mark-function using a
	portable representation of C-M-h that differentiates this from
	M-BS on both XEmacs and Emacs.

Sat Nov 15 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-electric-pound, c-electric-brace,
	c-electric-slash, c-electric-star, c-electric-semi&comma,
	c-electric-colon, c-electric-lt-gt, c-scope-operator,
	c-indent-command, c-indent-exp, c-indent-defun,
	c-backslash-region, c-fill-paragraph): Added "*" to interactive
	spec to barf-if-buffer-read-only.

Fri Nov 14 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-fill-paragraph): regexp-quote the fill-prefix when
	search forward for the end of line oriented comments.  This is in
	case the fill-prefix contains regexp special characters
	(e.g. fill-prefix == " //* ")

	(c-backslash-region): Do not preserve the zmacs region (XEmacs).

Wed Nov 12 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-langs.el (c-mode-base-map): c-mark-function moved back to
	M-C-h.  RMS says: "It ought to be on M-C-h, because that is the
	key to mark one function definition in whatever language you're
	using."  I don't remember why it was moved in the first place.

Tue Nov 04 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-cmds.el (c-electric-backspace, c-electric-delete):
	Interactive spec should have a read-only *.

Thu Oct 30 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-styles.el (c-styles-alist): Merged "jdk" into "java" style
	and removed "jdk" style.  Only differences now are inline-open and
	c-basic-offset.

Wed Oct 29 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-mode.texi Document "jdk" style.

	* cc-styles.el (c-style-alist): "jdk" style given by Martin
	Buchholz <mrb@Eng.Sun.COM> for conformance with Sun's JDK style.

Fri Oct 10 1997  Barry Warsaw  <cc-mode-help@python.org>

	* cc-styles.el (c-set-style-2, c-initialize-builtin-style): Don't
	special case "cc-mode", it's a derived style.

	Fix setup of derived style "cc-mode".

	Introduce the new default style "user" which contains all user
	customizations.  The style "cc-mode" is retained as an alias, but
	it's use is deprecated.  The default style variable has been
	renamed c-default-style.

	* cc-vars.el (c-site-default-style): Renamed to c-default-style.
	Also, the default value is now "user".

1998-01-24  SL Baur  <steve@altair.xemacs.org>

	* Makefile (VERSION): Update to package standard 1.0.
	* package-info.in: Ditto.

1998-01-17  SL Baur  <steve@altair.xemacs.org>

	* cc-mode.el (c-submit-bug-report): Move reporter dependency
	inside the function that uses it.

1998-01-09  SL Baur  <steve@altair.xemacs.org>

	* cc-engine: (c-guess-basic-syntax): Guard against c-access-key being
	nil.
	From Didier Verna <verna@inf.enst.fr>

1998-01-03  SL Baur  <steve@altair.xemacs.org>

	* Makefile: Update to newer package interface.

1997-12-25  SL Baur  <steve@altair.xemacs.org>

	* cc-engine.el: Add explicit dependency on cc-defs.
	* cc-styles.el: Ditto.

1997-12-21  SL Baur  <steve@altair.xemacs.org>

	* Makefile: Created.
